unit Novator2;

interface

uses
SysUtils, Classes, IdTCPClient, IdTCPConnection, Windows, Messages, Dialogs, Forms;

const
  // 
  NS = #13#10;
  // 
  WM_DIGITALS_CREATE_OBJECT = WM_USER + 1;
  // 
  WM_DIGITALS_CHANGE_OBJECT = WM_USER + 2;
  // 
  WM_DIGITALS_DELETE_OBJECT = WM_USER + 3;
  //  
  WM_DIGITALS_START_EDIT = WM_USER + 4;
  //   
  WM_DIGITALS_ADD_POINT = WM_USER + 5;
  //   
  WM_DIGITALS_DELETE_POINT = WM_USER + 6;
  // 
  WM_DIGITALS_STOP_EDIT = WM_USER + 7;
  // 
  WM_DIGITALS_SELECT_OBJECT = WM_USER + 8;
  // 
  WM_DIGITALS_ADD_OBJECTPOINT = WM_USER + 9;

Type
  {   }
  nlType = (nlGroup,nlPolygon,nlSpline,nlPoint,nlSymbol,nlFrame,nlTable,nlReliefModel,nlList,nlImg,nlTin,nlOle,nlCaption,nlTrajectory, nlModel, nlOthers);
  {   }
  npType = (npByte,npWord,npInteger,npFloat,npString,npBoolean,npFile,npList,npTable,npOthers);
  { }
  nPoint = record
    X:Double;
    Y:Double;
    Z:Double;
  end;
  pPoint = ^nPoint;

Type
  //     
  ENServerNotFind = class(EAbort);

  //   
  ENLogFileNotFind = class(EAbort);

  //   
  ENObjectNotExist = class(EAbort);

  //  
  ENAddRepeatObject = class(EAbort);

  //    
  ENTemplateNotFind = class(EAbort);

Type
  TNObjectList = class;
  {-----------------------------------------------------------------------------
  ,             TCP}
  TNConnector = class(TIdTCPClient)
  private
    //    
    function  TrySend(Com: String):TStringStream;
  public
    constructor Create(ServerPort:Integer; AplSelf: TForm);
    //  ,     
    function  SendRStream(Com: String):TStringStream;
  End;
  {-----------------------------------------------------------------------------
         }
  TEngMes = class(TThread)
    private
      m_MesagesHWND:HWND;
    protected
      procedure Execute; override;
    public
      constructor Create(MessagesHWND:HWND);
  end;

  {-----------------------------------------------------------------------------
       }
  TReadLog = class(TThread)
  private
    m_DirLogFile:String;
    m_PathLogFile:String;
    m_HandleChange: THandle;
    m_Size:Int64;
    m_EngMes:TEngMes;
    procedure ReadData();
    function TryOpenLog():TFileStream;
  protected
    procedure Execute; override;
  public
    constructor Create(PathLogFile:String;MesHWND:HWND);
    destructor  Destroy();
  end;

  {-----------------------------------------------------------------------------
  ,      }
  TRTEng = class(TThread)
    private
      m_AplHWND:HWND;
      m_Connector:TNConnector;
    protected
      procedure Execute; override;
    public
      constructor Create();
  end;


  {-----------------------------------------------------------------------------
          }
  TNBaseObject = class(TObject)
    private
      m_MapNumber: Integer;
      m_MapNumberStr: String;
      m_Connector:TNConnector;
    public
      constructor Create(MNumber:Integer = -1);
      property MapNumber: Integer Read m_MapNumber;
   End;

   {----------------------------------------------------------------------------
          }
   TNMapMember = class(TNBaseObject)
    private
      m_MemberNumber:Integer;
      m_MemberNumberStr: String;
    public
      constructor Create(MemNumber:Integer; MNamber:Integer = -1);
      property MemberNumber:Integer Read m_MemberNumber;
    end;

   {----------------------------------------------------------------------------
        }
   TNMapMembers = class(TNBaseObject)
    private
      //Count
      function GetCount: Integer; virtual; abstract;
    public
      property Count:Integer Read GetCount;
    end;

   {----------------------------------------------------------------------------
        }
   TNPoint = class(TNMapMember)
    private
      m_Number: Integer;
      m_NumberStr: String;
      //X
      function GetX():Double;
      procedure SetX(Value:Double);
      //Y
      function GetY():Double;
      procedure SetY(Value:Double);
      //Z
      function GetZ():Double;
      procedure SetZ(Value:Double);
      //CoordString
      function  GetCoordString:String;
    public
      constructor Create(PNumber:Integer; MemNumber: Integer; MNumber:Integer = -1 );
      property Number: Integer Read m_Number;
      property X: Double Read GetX Write SetX;
      property Y: Double Read GetY Write SetY;
      property Z: Double Read GetZ Write SetZ;
      property CoordString:String read GetCoordString;
      procedure Delete;
    end;

    {---------------------------------------------------------------------------
         }
    TNPoints = class(TNMapMembers)
      private
        m_MemberNumber:Integer;
        m_MemberNumberStr: String;
        function  GetCount: Integer; override;
      public
        constructor Create(MemNumber:Integer; MNumber:Integer = -1);
        property  MemberNumber: Integer Read m_MemberNumber;
        function GetOfNumber(PointNumber:Integer):TNPoint;
        function  Add(X,Y,Z:Double):Integer; overload;
        function  Add(Point:TNPoint):Integer; overload;
        procedure Delete(PointNumber:Integer);
    end;

    {---------------------------------------------------------------------------
          }
    TNPointList = class(TList)
      public
        function GetPoint(PointNumber:Integer):nPoint;
        procedure AddPoint(mPoint:nPoint); overload;
        procedure AddPoint(X,Y,Z:Double);overload;
    end;

    {---------------------------------------------------------------------------
         }
    TNMapParameter = class(TNMapMember)
      private
        //Name
        function GetName():String;
        procedure SetName(Value:String);
        //ParameterType
        function GetParameterType():npType;
        procedure SetParameterType(Value:npType);
        //Code
        function GetCode:Integer;
        procedure SetCode(Value:Integer);
      public
        property Name:String read GetName write SetName;
        property ParameterType:npType read GetParameterType write SetParameterType;
        property  Code:Integer read GetCode write SetCode;
    end;

    {      }
    TNMapParameters = class(TNMapMembers)
      private
        function GetCount():Integer; override;
      public
        function Add(Code:Integer;Name:String;ParameterType:npType):Integer; overload;
        function Add(MapParameter:TNMapParameter):Integer; overload;
        function GetOfNumber(Number:Integer): TNMapParameter;
        function GetOfCode(Code:Integer): TNMapParameter;
        function GetOfName(Name:String): TNMapParameter;
    end;

    {---------------------------------------------------------------------------
         }
    TNLayerParameter = class(TNMapMember)
      private
        m_Number:Integer;
        m_NumberStr:String;
        //Code
        function GetCode():Integer;
        function GetType():npType;
        function GetName():String;
      public
        property Number:Integer read m_Number;
        constructor Create(ParamNumber:Integer; LayerNumber:Integer;MNumber:Integer = -1);
        property  Code:Integer read GetCode;
        property  ParameterType:npType read GetType;
        property  Name:String read GetName;
    end;

    {---------------------------------------------------------------------------
          }
    TNLayerParameters = class(TNMapMembers)
      private
        m_MemberNumber:Integer;
        m_MemberNumberStr:String;
        function GetCount():Integer; override;
      public
        constructor Create(LayerNumber:Integer;MNumber:Integer = -1);
        property    MemberNumber:Integer read m_MemberNumber;
        procedure   AddParameter(MapParameter:TNMapParameter);
        procedure   DeleteParameter(MapParameter:TNMapParameter);
        function    GetOfNumber(NumberOfList:Integer):TNLayerParameter;
    end;

    {---------------------------------------------------------------------------
         }
    TNMapLayer = class(TNMapMember)
      private
        m_Parameters:TNLayerParameters;
        //LayerType
        function GetLayerType():nlType;
        procedure SetLayerType(Value:nlType);
        //Code
        function GetCode():Integer;
        procedure SetCode(Value:Integer);
        //Name
        function  GetName():String;
        procedure SetName(Value:String);
      public
        property Parameters:TNLayerParameters read m_Parameters write m_Parameters;
        constructor Create(MemNumber:Integer;MNumber:Integer = -1);
        property LayerType: nlType read GetLayerType write SetLayerType;
        property Code: Integer read GetCode write SetCode;
        property  Name: String read GetName write SetName;
    end;

    {---------------------------------------------------------------------------
         }
    TNObjectLayer = class(TNMapMember)
      private
        //Number
        function  GetLayerNumber():Integer;
        procedure SetLayerNumber(Value:Integer);
        //Name
        function  GetName():String;
        procedure SetName(Value:String);
        //LayerType
        function GetLayerType:nlType;
        //Code
        function GetCode():Integer;
        procedure SetCode(Value:Integer);
      public
        property LayerNumber: Integer read GetLayerNumber write SetLayerNumber;
        property Name:String read GetName write SetName;
        property LayerType:nlType read GetLayerType;
        property Code:Integer read GetCode write SetCode;
    end;

    {---------------------------------------------------------------------------
         }
    TNMapLayers = class(TNMapMembers)
      private
        function GetCount():Integer; override;
      public
      function Add(Code:Integer;Name:String;LayerType:nlType):Integer; overload;
      function Add(MapLayer:TNMapLayer):Integer; overload;
      function GetOfNumber(Number:Integer):TNMapLayer;
      function  GetOfCode(Code:Integer):TNMapLayer;
      function GetOfName(Name:String):TNMapLayer;
    end;

    {---------------------------------------------------------------------------
         }
    TNObjectParameter = class(TNMapMember)
      private
        m_Number:Integer;
        m_NumberStr:String;
        //Name
        function GetName():String;
        //Code
        function GetCode():Integer;
        //Type
        function GetType():npType;
        //Value
        function GetValue():String;
        procedure SetValue(mValue:String);
      public
        constructor Create(ParamNumber:Integer; MemNumber:Integer; MNUmber:Integer = -1);
        property ParameterNumber:Integer read m_Number;
        property Name:String read GetName;
        property Code:Integer read GetCode;
        property ParameterType:npType read GetType;
        property Value:String read GetValue write SetValue;
    End;

    {---------------------------------------------------------------------------
          }
    TNObjectParameters = class(TNMapMembers)
      private
        m_MemberNumber:Integer;
        m_MemberNumberStr:String;
        function GetCount():Integer; override;
      public
        constructor Create(ObjectNumber:Integer;MNumber:Integer=-1);
        property MemberNumber:Integer read m_MemberNumber;
        function GetOfNumber(NumberOfList:Integer):TNObjectParameter;
        function GetOfCode(Code:Integer):TNObjectParameter;
        function GetOfName(Name:String):TNObjectParameter;
    End;

    {---------------------------------------------------------------------------
        }
    TNObject = class(TNMapMember)
      private
        m_Layer:TNObjectLayer;
        m_Points:TNPoints;
        m_Parameters:TNObjectParameters;
        //Layer
        procedure SetLayer(Value:TNObjectLayer);
        //Points
        procedure SetPoints(Value:TNPoints);
      public
        constructor Create(ObjectNumber:Integer;mMapNumber:Integer = -1);
        property Layer:TNObjectLayer read m_Layer write SetLayer;
        property Points:TNPoints read m_Points write SetPoints;
        property Parameters :TNObjectParameters read m_Parameters;
        procedure Delete();
    end;

    {---------------------------------------------------------------------------
         }
    TNObjects = class(TNMapMembers)
      private
        function GetCount():Integer;override;
      public
        function GetOfNumber(NumberOfList:Integer):TNObject;
        function Add(mLayer:TNMapLayer; mMapNumber:Integer = -1):Integer;
    end;

    {---------------------------------------------------------------------------
        }
    TNMap = class(TNBaseObject)
      private
        m_Objects:TNObjects;
        m_Parameters:TNMapParameters;
        m_Layers:TNMapLayers;
        //Name
        function GetName():String;
      public
        constructor Create(mMapNumber:Integer = -1);overload;
        constructor Create(TempLate:String); overload;
        property Name:String read GetName;
        property Objects:TNObjects read m_Objects;
        property Parameters:TNMapParameters read m_Parameters;
        property Layers:TNMapLayers read m_Layers;
        procedure SaveAs(mName:String);
        function SelectedObjects():TNObjectList;
    end;

    {---------------------------------------------------------------------------
          }
    TNObjectList = class(TStringList)
      private
        m_MapNumber:Integer;
      public
        constructor Create(mMapNumber:Integer = -1);
        function GetObject(ObjectNumber:Integer):TNObject;
        procedure LoadNumberList(NumbersObject:TStream);
        function AddObject(ObjectNumber:Integer):Integer;
    end;

//==============================================================================
//=============================== ==========================
//==============================================================================
var
  //        
  ApplicationSelf:TForm;
  //   
  ServerComandPort: Integer;
  //     
  Connector: TNConnector = NIL;
  //     
  CountTrySend:Integer = 10;
  //  
  WaitReply:Integer = 0;
  //   
  WaitRT:Integer = 75;
  //   
  RTEngineStream:TRTEng = nil;
  //     
  WM_MYKEYHOOK: Cardinal;
  //     
  WM_MYMOUSEHOOK: Cardinal;

//==============================================================================
//============================== ============================== 
//==============================================================================
  //   
  procedure NovatorStart(AplSelf:TForm; ServerPort:Integer; MesEngine:Boolean; RTServer:Boolean; SynServer:Boolean);

  //   
  procedure NovatorStop();

  //  
  procedure  RTEngine();

implementation

uses Math;
//==============================================================================
//========================== ========================== 
//==============================================================================
var
  //   
  GMESLISTDATA:TList;
  //  
  m_ReadLog: TReadLog = nil;
  // 
  HookProc: procedure (switch : Boolean; hMainProg: HWND) stdcall;
  //    
  PrevCount:Integer = -1;
  //  
  OnCapture: Boolean;
  //    
  PrevPointCount:Integer;
  // 
  SelFirstObj:Integer = -1;
  SelCountObj:Integer = -1;



//==============================================================================
//===================  ================================  
//==============================================================================
//   
  procedure NovatorStart(AplSelf:TForm; ServerPort:Integer; MesEngine:Boolean; RTServer:Boolean; SynServer:Boolean);
    VAR MapName: String;
        hDLL:THandle;
        MapCount:Integer;
    BEGIN
    //    
    Connector := TNConnector.Create(ServerPort,AplSelf);

    //  
    if MesEngine then
      if (Connector <> nil) then
        Begin
        MapName := Connector.SendRStream('Map.FileName').DataString;
        if MapName  <> '<ERROR> No opened map' then
          Begin
          if FileExists(ChangeFileExt(MapName,'.log')) then
            m_ReadLog := TReadLog.Create(MapName,ApplicationSelf.Handle)
          Else
            ShowMessage('  log    '+ MapName + '   log   ');
          End
        else
          ShowMessage('  .   log   ');
        End;

    //     

    if RTServer then
      Begin
      MapCount := StrToInt(Connector.SendRStream('MapCount').DataString);
      If MapCount > 0 then
        Begin
        // 
        @hookProc:= nil;
        hDLL:= LoadLibrary(PChar('hook.dll'));
        @hookProc:=GetProcAddress(Hdll, 'HookProc');
        hookProc(true, ApplicationSelf.Handle);

        //    
        PrevCount := StrToInt(Connector.SendRStream('Map.Count').DataString);

        // 
        OnCapture := False;
        PrevPointCount := 0;
        RTEngineStream := TRTEng.Create();

        //   
        WaitReply := 0;

        // 
        WM_MYKEYHOOK:= RegisterWindowMessage('WM_MYKEYHOOK');
        WM_MYMOUSEHOOK:= RegisterWindowMessage('WM_MYMOUSEHOOK');
        End
      else
        Begin
        ShowMessage('  .      ');
        End;
      End;
    END;

//==============================================================================
//  
  procedure NovatorStop();
    BEGIN
    // 
    FreeAndNil(Connector);

    //  
    ServerComandPort := 0;

    // 
    if m_ReadLog  <> nil then
      Begin
      m_ReadLog.Suspended := False;
      End;


    // 
    If RTEngineStream <> nil then
      Begin
      HookProc(False,ApplicationSelf.Handle);
      RTEngineStream.Terminate;
      End;

    END;
//==============================================================================
//  
procedure  RTEngine();
  Var CurCount:Integer;
      SelectNumber:String;
      CurPointCount:Integer;
      SelCount:Integer;
  BEGIN
  // 
  HookProc(False,ApplicationSelf.Handle);

  SelectNumber := Connector.SendRStream('Map.NextSelected 0').DataString;
  if SelectNumber = '0' then
      Begin
      //  
      CurCount := StrToInt(Connector.SendRStream('Map.Count').DataString);
      if CurCount > PrevCount then
          Begin
          //   
          PrevCount := CurCount;
          PostMessage(ApplicationSelf.Handle, WM_DIGITALS_ADD_OBJECTPOINT,PrevCount,0);
          End
      else
          Begin
          //   
          if OnCapture then
              Begin
              // 
              OnCapture := False;
              PostMessage(ApplicationSelf.Handle, WM_DIGITALS_STOP_EDIT ,PrevCount,0);
              End;
          End;
      End
  else
      Begin
      //  
      CurCount := StrToInt(Connector.SendRStream('Map.Count').DataString);
      if CurCount > PrevCount then
          Begin
          // 
          OnCapture := True;
          PrevPointCount := 1;
          PrevCount := CurCount;
          PostMessage(ApplicationSelf.Handle, WM_DIGITALS_START_EDIT,PrevCount,0);
          End
      else
          Begin
          //  
          if OnCapture then
              Begin
              //   
              CurPointCount  := StrToInt(Connector.SendRStream('Map.Object['+IntToStr(PrevCount)+'].Count').DataString) - 1;
              if CurPointCount > PrevPointCount then
                  Begin
                  // 
                  PrevPointCount := CurPointCount;
                  PostMessage(ApplicationSelf.Handle, WM_DIGITALS_ADD_POINT ,PrevCount,CurPointCount);
                  End;

              if CurPointCount < PrevPointCount then
                  Begin
                  // 
                  PostMessage(ApplicationSelf.Handle, WM_DIGITALS_DELETE_POINT ,PrevCount,PrevPointCount);
                  PrevPointCount := CurPointCount;
                  End;
              End
          else
              Begin
              // 
              SelCount := StrToInt(Connector.SendRStream('Map.SelCount').DataString);
              if ((SelFirstObj <> StrToInt(SelectNumber)) or (SelCountObj <> SelCount)) then
                  Begin
                  SelFirstObj := StrToInt(SelectNumber);
                  SelCountObj := SelCount;
                  PostMessage(ApplicationSelf.Handle, WM_DIGITALS_SELECT_OBJECT ,StrToInt(SelectNumber),SelCount);
                  End;
              End;
          End;
      End;

  // 
  HookProc(True,ApplicationSelf.Handle);
  END;

//==============================================================================
//======================== =============================== 
//==============================================================================
//     NLType
function IntToNLType(Value:Integer):nlType;
  BEGIN
  case  Value of
    0: IntToNLType := nlGroup;
    1: IntToNLType := nlPolygon;
    2: IntToNLType := nlSpline;
    3: IntToNLType := nlPoint;
    4: IntToNLType := nlSymbol;
    5: IntToNLType := nlFrame;
    6: IntToNLType := nlTable;
    7: IntToNLType := nlReliefModel;
    8: IntToNLType := nlList;
    9: IntToNLType := nlImg;
    10: IntToNLType := nlTin;
    11: IntToNLType := nlOle;
    12: IntToNLType := nlCaption;
    13: IntToNLType := nlTrajectory;
    14: IntToNLType := nlModel
  else
    IntToNLType := nlOthers;
  end;
  END;

//  NLType  
function NLTypeToInt(Value:nlType):Integer;
  BEGIN
  case Value of
    nlGroup : NLTypeToInt := 0;
    nlPolygon : NLTypeToInt := 1;
    nlSpline : NLTypeToInt := 2;
    nlPoint : NLTypeToInt := 3;
    nlSymbol : NLTypeToInt := 4;
    nlFrame : NLTypeToInt := 5;
    nlTable : NLTypeToInt := 6;
    nlReliefModel : NLTypeToInt := 7;
    nlList : NLTypeToInt := 8;
    nlImg : NLTypeToInt := 9;
    nlTin : NLTypeToInt := 10;
    nlOle : NLTypeToInt := 11;
    nlCaption : NLTypeToInt := 12;
    nlTrajectory : NLTypeToInt := 13;
    nlModel  : NLTypeToInt := 14;
  else
    NLTypeToInt := -1;
  end;
  END;

//     NPType
function IntToNPType(Value:Integer):npType;
  BEGIN
  case  Value of
    1: IntToNPType := npByte;
    2: IntToNPType := npByte;
    3: IntToNPType := npInteger;
    4: IntToNPType := npFloat;
    5: IntToNPType := npString;
    6: IntToNPType := npBoolean;
    7: IntToNPType := npFile;
    8: IntToNPType := npList;
    9: IntToNPType := npTable
  else
    IntToNPType := npOthers;
  end;
  END;

//  NPType  
function NPTypeToInt(Value:npType):Integer;
  BEGIN
  case Value of
    npByte : NPTypeToInt := 1;
    npWord : NPTypeToInt := 2;
    npInteger : NPTypeToInt := 3;
    npFloat : NPTypeToInt := 4;
    npString : NPTypeToInt := 5;
    npBoolean : NPTypeToInt := 6;
    npFile : NPTypeToInt := 7;
    npList : NPTypeToInt := 8;
    npTable : NPTypeToInt := 9
  else
    NPTypeToInt := -1;
  end;
  END;

//==============================================================================
//============================TNConnector=======================================TNConnector
//==============================================================================
  constructor TNConnector.Create(ServerPort:Integer; AplSelf: TForm);
    VAR SerRec:String;
    BEGIN
      TRY
          inherited Create(AplSelf);

          Port := ServerPort;
          Host := 'localhost';

          ApplicationSelf := AplSelf;
          ServerComandPort := Port;

          RecvBufferSize := 1024;
          ReadTimeout := 30;

          Connect(15);
          SerRec := CurrentReadBuffer;
      EXCEPT
          raise ENServerNotFind.Create('     Digitals:' + NS + ': '+ 'localhost;'+ NS + ': '+ IntToStr(ServerComandPort )+';');
      END;
    END;

//==============================================================================
//  ,     
  function  TNConnector.SendRStream(Com: String):TStringStream;
    VAR TempReply:TStringStream;
        TempCountTrySend:Integer;
    BEGIN
    TempCountTrySend := CountTrySend;

    //   
    repeat
      TempReply := TrySend(Com);
      TempCountTrySend := TempCountTrySend - 1;
    until ((TempCountTrySend = 0)or(TempReply<>nil));

    //      ,   
    if TempCountTrySend = 0 then
        raise ENServerNotFind.Create('     Digitals:' + NS + ': '+ 'localhost;'+ NS + ': '+ IntToStr(ServerComandPort )+';');

    Sleep(WaitReply);
    SendRStream := TempReply;
    END;

//==============================================================================
//    
  function  TNConnector.TrySend(Com: String): TStringStream;
    VAR TempStream:TStringStream;
        TempRec: String;
    BEGIN
      TRY
      //  
      Write(Com);

      TempStream := TStringStream.Create('');
      repeat
        TempRec :=  CurrentReadBuffer;
        TempStream.WriteString(TempRec);
      until Length(TempRec) <> 1024;

      TempStream.Position := 0;
      TrySend := TempStream;
      EXCEPT
        // ,    
        TrySend := nil;
      END;
    END;

//==============================================================================
//======================TEngMes=================================================TEngMes
//==============================================================================
//   
constructor TEngMes.Create(MessagesHWND:HWND);
  BEGIN
  inherited Create(True);

  m_MesagesHWND := MessagesHWND;
  Self.Priority := tpNormal;
  Resume;
  END;

//==============================================================================
//  
procedure TEngMes.Execute;
  VAR S:TMemoryStream;
      L,LT:TStringList;
      i:integer;
  BEGIN
  While not Terminated do
    If GMESLISTDATA.Count > 0 then
      Begin
      //  
      S := GMESLISTDATA.Items[0];

      S.Position := 0;
      L := TStringList.Create;
      L.LoadFromStream(S);
      S.Free;

      LT := TStringList.Create;
      For i:=0 to L.Count - 1 do
        Begin
        LT.Delimiter := #9;
        LT.QuoteChar := #0;
        LT.CommaText := L.Strings[i];

        if LT.Strings[LT.Count - 2] <> '' Then
          Begin
          if LT.Strings[LT.Count - 3] = '' Then
            Begin
            //  
            PostMessage(m_MesagesHWND,WM_DIGITALS_CREATE_OBJECT,StrToInt(LT.Strings[LT.Count - 1]),0);
            End
          else
            If LT.Strings[LT.Count - 3] = '' Then
              Begin
              //  
              PostMessage(m_MesagesHWND,WM_DIGITALS_CHANGE_OBJECT,StrToInt(LT.Strings[LT.Count - 1]),0);
              End
            Else
              If LT.Strings[LT.Count - 3] = '' Then
                Begin
                //  
                PostMessage(m_MesagesHWND,WM_DIGITALS_DELETE_OBJECT,StrToInt(LT.Strings[LT.Count - 1]),0);
                End;
          End;
        End;
      GMESLISTDATA.Delete(0);
      GMESLISTDATA.Pack;
      End
    else
      Begin
      //   
      Suspend;
      End;
  END;


//==============================================================================
//======================TReadLog================================================
//==============================================================================
//   
function TReadLog.TryOpenLog():TFileStream;
  VAR F:TFileStream;
  BEGIN
    TRY
      F := TFileStream.Create(m_PathLogFile,fmOpenRead,fmShareDenyNone);
      TryOpenLog := F;
    EXCEPT
      TryOpenLog := NIL;
      Sleep(15);
    END
  END;

//==============================================================================
//      
constructor TReadLog.Create(PathLogFile:String;MesHWND:HWND);
  VAR F:TFileStream;
  BEGIN
  inherited Create(True);

  GMESLISTDATA := TList.Create;
  m_EngMes := TEngMes.Create(MesHWND);

  m_DirLogFile := ExtractFilePath(PathLogFile);
  m_PathLogFile := ChangeFileExt(PathLogFile,'.log');
  Self.Priority := tpNormal;
  if FileExists(m_PathLogFile) Then
    Begin
      Repeat
        F := TryOpenLog;
      Until  (F <> NIL);

      m_Size := F.Size;
      F.Free;
    End;
  Resume;
  END;

//==============================================================================
//    
procedure TReadLog.Execute;
  BEGIN
  m_HandleChange := FindFirstChangeNotification(PChar(m_DirLogFile),False,FILE_NOTIFY_CHANGE_SIZE);
  Win32Check(m_HandleChange <> INVALID_HANDLE_VALUE);

  While WaitForSingleObject(m_HandleChange,INFINITE) = WAIT_OBJECT_0 do
    Begin
    ReadData();
    FindNextChangeNotification(m_HandleChange);
    End;
  END;

//==============================================================================
//    
procedure TReadLog.ReadData;
  VAR F:TFileStream;
      S:TMemoryStream;
  BEGIN
  If FileExists(m_PathLogFile) Then
    Begin
      Repeat
        F := TryOpenLog
      Until (F<>NIL);

      F.Position := m_Size;
      S := TMemoryStream.Create;
      S.CopyFrom(F,F.Size - F.Position);
      m_Size := F.Size;
      F.Free;
      GMESLISTDATA.Add(S);
    End;
  m_EngMes.Resume;  
  END;

//==============================================================================
//      
destructor  TReadLog.Destroy;
  BEGIN
  FindCloseChangeNotification(m_HandleChange);
  m_EngMes.Destroy;
  FreeAndNil(GMESLISTDATA);
  inherited Destroy;
  END;

{===============================================================================
====================================TRTEng======================================
===============================================================================}
constructor TRTEng.Create();
  BEGIN
  inherited Create(True);
  Self.Priority := tpNormal;
  END;

//------------------------------------------------------------------------------
//  
procedure TRTEng.Execute;
  BEGIN
  while not Terminated do
      Begin
      Sleep(WaitRT);
      if Connector <> nil then
        RTEngine;
      Suspend;
      End;
  END;

{===============================================================================
===================================TNBaseObject=================================TNBaseObject
===============================================================================}
Constructor TNBaseObject.Create(MNumber:Integer = -1);
  BEGIN
    inherited Create();

    m_MapNumber := MNumber;
    m_MapNumberStr := IntToStr(MNumber);

    m_Connector := Connector;
  END;

{===============================================================================
===================================TNMapMember=================================TNMapMember
===============================================================================}
Constructor TNMapMember.Create(MemNumber:Integer; MNamber:Integer = -1);
  BEGIN
    inherited Create(MNamber);

    m_MemberNumber := MemNumber;
    m_MemberNumberStr := IntToStr(MemNumber);
  END;


{===============================================================================
=======================================TNPoint=================================TNPoint
===============================================================================}
Constructor TNPoint.Create(PNumber:Integer; MemNumber: Integer; MNumber:Integer = -1 );
  BEGIN
    inherited Create(MemNumber,MNumber);

    m_Number := PNumber;
    m_NumberStr := IntToStr(PNumber);
  END;

//X
function TNPoint.GetX():Double;
  VAR TempX:String;
  BEGIN
  if m_MapNumber = -1 then
    Begin
    TempX := Connector.SendRStream('Map.Object['+m_MemberNumberStr+'].Point['+m_NumberStr+'].X').DataString;
    if TempX[1] <> '<' then
      GetX := StrToFloat(TempX)
    else
      raise ENObjectNotExist.Create('   : ' + m_NumberStr + ', : ' + m_MemberNumberStr +',  ' );
    End
  Else
    Begin
    TempX := Connector.SendRStream('Map['+ m_MapNumberStr +'].Object['+m_MemberNumberStr+'].Point['+m_NumberStr+'].X').DataString;
    if TempX[1] <> '<' then
      GetX := StrToFloat(TempX)
    else
      raise ENObjectNotExist.Create('   : ' + m_NumberStr + ', : ' + m_MemberNumberStr + ', : ' + m_MapNumberStr );
    End;

  END;

procedure TNPoint.SetX(Value: Double);
  VAR TempReply:String;
  BEGIN
  if m_MapNumber = -1 then
    Begin
    TempReply  := Connector.SendRStream('Map.Object['+ m_MemberNumberStr +'].Point['+m_NumberStr +'].X '+ FloatToStrF(Value,ffFixed,10,3)).DataString;
    if TempReply[1] = '<' then
      raise ENObjectNotExist.Create('   : ' + m_NumberStr + ', : ' +  m_MemberNumberStr + '  ');
    End
  Else
    Begin
    TempReply  := Connector.SendRStream('Map['+ m_MapNumberStr +'].Object['+ m_MemberNumberStr +'].Point['+m_NumberStr +'].X '+ FloatToStrF(Value,ffFixed,10,3)).DataString;
    if TempReply[1] = '<' then
      raise ENObjectNotExist.Create('   : ' + m_NumberStr + ', : ' +  m_MemberNumberStr+ ', : ' + m_MapNumberStr);
    End;
  END;

//Y
function TNPoint.GetY():Double;
  VAR TempY:String;
  BEGIN
  if m_MapNumber = -1 then
    Begin
    TempY := Connector.SendRStream('Map.Object['+m_MemberNumberStr+'].Point['+m_NumberStr+'].Y').DataString;
    if TempY[1] <> '<' then
      GetY := StrToFloat(TempY)
    else
      raise ENObjectNotExist.Create('   : ' + m_NumberStr + ', : ' + m_MemberNumberStr +',  ' );
    End
  Else
    Begin
    TempY := Connector.SendRStream('Map['+ m_MapNumberStr +'].Object['+m_MemberNumberStr+'].Point['+m_NumberStr+'].Y').DataString;
    if TempY[1] <> '<' then
      GetY := StrToFloat(TempY)
    else
      raise ENObjectNotExist.Create('   : ' + m_NumberStr + ', : ' + m_MemberNumberStr + ', : ' + m_MapNumberStr);
    End;

  END;

procedure TNPoint.SetY(Value: Double);
  VAR TempReply:String;
  BEGIN
  if m_MapNumber = -1 then
    Begin
    TempReply  := Connector.SendRStream('Map.Object['+ m_MemberNumberStr +'].Point['+m_NumberStr +'].Y '+ FloatToStrF(Value,ffFixed,10,3)).DataString;
    if TempReply[1] = '<' then
      raise ENObjectNotExist.Create('   : ' + m_NumberStr + ', : ' +  m_MemberNumberStr + '  ');
    End
  Else
    Begin
    TempReply  := Connector.SendRStream('Map['+ m_MapNumberStr +'].Object['+ m_MemberNumberStr +'].Point['+m_NumberStr +'].Y '+ FloatToStrF(Value,ffFixed,10,3)).DataString;
    if TempReply[1] = '<' then
      raise ENObjectNotExist.Create('   : ' + m_NumberStr + ', : ' +  m_MemberNumberStr+ ', : ' + m_MapNumberStr );
    End;
  END;

//Z
function TNPoint.GetZ():Double;
  VAR TempZ:String;
  BEGIN
  if m_MapNumber = -1 then
    Begin
    TempZ := Connector.SendRStream('Map.Object['+m_MemberNumberStr+'].Point['+m_NumberStr+'].Z').DataString;
    if TempZ[1] <> '<' then
      GetZ := StrToFloat(TempZ)
    else
      raise ENObjectNotExist.Create('   : ' + m_NumberStr + ', : ' + m_MemberNumberStr +',  ' );
    End
  Else
    Begin
    TempZ := Connector.SendRStream('Map['+ m_MapNumberStr +'].Object['+m_MemberNumberStr+'].Point['+m_NumberStr+'].Z').DataString;
    if TempZ[1] <> '<' then
      GetZ := StrToFloat(TempZ)
    else
      raise ENObjectNotExist.Create('   : ' + m_NumberStr + ', : ' + m_MemberNumberStr + ', : ' + m_MapNumberStr);
    End;
  END;

procedure TNPoint.SetZ(Value: Double);
  VAR TempReply:String;
  BEGIN
  if m_MapNumber = -1 then
    Begin
    TempReply  := Connector.SendRStream('Map.Object['+ m_MemberNumberStr +'].Point['+m_NumberStr +'].Z '+ FloatToStrF(Value,ffFixed,10,3)).DataString;
    if TempReply[1] = '<' then
      raise ENObjectNotExist.Create('   : ' + m_NumberStr + ', : ' +  m_MemberNumberStr + '  ');
    End
  Else
    Begin
    TempReply  := Connector.SendRStream('Map['+ m_MapNumberStr +'].Object['+ m_MemberNumberStr +'].Point['+m_NumberStr +'].Z '+ FloatToStrF(Value,ffFixed,10,3)).DataString;
    if TempReply[1] = '<' then
      raise ENObjectNotExist.Create('   : ' + m_NumberStr + ', : ' +  m_MemberNumberStr+ ', : ' + m_MapNumberStr);
    End;
  END;

//CoordString
function TNPoint.GetCoordString():String;
  VAR TempCS:String;
  BEGIN
  if m_MapNumber = -1 then
    Begin
    TempCS := Connector.SendRStream('Map.Object['+m_MemberNumberStr+'].Point['+m_NumberStr+']').DataString;
    if TempCS[1] <> '<' then
      GetCoordString := TempCS
    else
      raise ENObjectNotExist.Create('   : ' + m_NumberStr + ', : ' + m_MemberNumberStr +',  ' );
    End
  Else
    Begin
    TempCS := Connector.SendRStream('Map['+ m_MapNumberStr +'].Object['+m_MemberNumberStr+'].Point['+m_NumberStr+'].Z').DataString;
    if TempCS[1] <> '<' then
      GetCoordString := TempCS
    else
      raise ENObjectNotExist.Create('   : ' + m_NumberStr + ', : ' + m_MemberNumberStr + ', : ' + m_MapNumberStr);
    End;
  END;

//   
procedure TNPoint.Delete;
  VAR TempState:TStringList;
      CountPoint:Integer;
      i:Integer;
      TempStr:String;
  BEGIN
  TempState := TStringList.Create;
  if m_MapNumber = -1 then
    Begin
    TempState.LoadFromStream(Connector.SendRStream('Map.GetObjectCoordinates '+ m_MemberNumberStr));
    if TempState.Count = 1 then
      raise ENObjectNotExist.Create('   : '+ m_MemberNumberStr + ',  ')
    else
      Begin
      CountPoint :=  StrToInt(TempState.Strings[2]);
      if CountPoint < m_Number then
        raise ENObjectNotExist.Create('   : ' + m_NumberStr +', : ' + m_MemberNumberStr + ',  ' )
      else
        Begin
        TempState.Strings[2] := IntToStr(CountPoint-1);
        TempState.Delete(m_Number+2);
        TempStr := '';
        for i:=0 to TempState.Count -1 do
          TempStr := TempStr + TempState.Strings[i] + NS;
        Connector.SendRStream('Map.PutObjectCoordinates ' + m_MemberNumberStr + NS + TempStr);
        End;
      End;
    End
  else
    Begin
    TempState.LoadFromStream(Connector.SendRStream('Map['+m_MapNumberStr+'].GetObjectCoordinates '+ m_MemberNumberStr));
    if TempState.Count = 1 then
      raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr +', : '+m_MapNumberStr)
    else
      Begin
      CountPoint :=  StrToInt(TempState.Strings[2]);
      if CountPoint < m_Number then
        raise ENObjectNotExist.Create('   : ' + m_NumberStr +', : ' + m_MemberNumberStr + ', : ' + m_MapNumberStr )
      else
        begin
        TempState.Strings[2] := IntToStr(CountPoint);
        TempState.Delete(m_Number+2);
        TempStr := '';
        for i:=0 to TempState.Count -1 do
          TempStr := TempStr + TempState.Strings[i] + NS;
        Connector.SendRStream('Map['+m_MapNumberStr+'].PutObjectCoordinates ' + m_MemberNumberStr + NS + TempStr);
        end;
      End;
    End;
  FreeAndNil(TempState);
  Destroy;
  END;


{===============================================================================
=======================================TNPoints=================================TNPoints
===============================================================================}
constructor TNPoints.Create(MemNumber:Integer; MNumber:Integer = -1);
  BEGIN
    inherited Create(MNumber);

    m_MemberNumber := MemNumber;
    m_MemberNumberStr := IntToStr(MemNumber);
  END;

//    
function TNPoints.GetOfNumber(PointNumber: Integer): TNPoint;
  BEGIN
  GetOfNumber := TNPoint.Create(PointNumber,m_MemberNumber,m_MapNumber);
  END;

//    
function TNPoints.GetCount():Integer;
  VAR TempCount:String;
  BEGIN
  if m_MapNumber = -1 then
    Begin
    TempCount := Connector.SendRStream('Map.Object['+m_MemberNumberStr+'].Count').DataString;
    if TempCount[1] <> '<' then
      GetCount := StrToInt(TempCount)
    else
      raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr +',  ' );
    End
  Else
    Begin
    TempCount := Connector.SendRStream('Map['+ m_MapNumberStr  +'].Object['+m_MemberNumberStr+'].Count').DataString;
    if TempCount[1] <> '<' then
      GetCount := StrToInt(TempCount)
    else
      raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr + ', : ' + m_MapNumberStr);
    End;
  END;

//    
function TNPoints.Add(X,Y,Z:Double):Integer;
  VAR TempState:TStringList;
      CountPoint:Integer;
      i:Integer;
      TempStr:String;
  BEGIN
  TempState := TStringList.Create;
  if m_MapNumber = -1 then
    Begin
    TempState.LoadFromStream(Connector.SendRStream('Map.GetObjectCoordinates '+ m_MemberNumberStr));
    if TempState.Count = 1 then
      raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr +',  ' )
    else
      Begin
      CountPoint :=  StrToInt(TempState.Strings[2]) + 1;
      TempState.Strings[2] := IntToStr(CountPoint);
      TempState.Add('0 '+FloatToStrF(X,ffFixed,10,3)+' '+ FloatToStrF(Y,ffFixed,10,3)+' '+FloatToStrF(Z,ffFixed,10,3));
      TempStr := '';
      for i:=0 to TempState.Count -1 do
        TempStr := TempStr + TempState.Strings[i] + NS;
      Connector.SendRStream('Map.PutObjectCoordinates ' + m_MemberNumberStr + NS + TempStr);
      Add := CountPoint;
      End;
    End
  else
    Begin
    TempState.LoadFromStream(Connector.SendRStream('Map['+m_MapNumberStr+'].GetObjectCoordinates '+ m_MemberNumberStr));
    if TempState.Count = 1 then
      raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr +', : '+m_MapNumberStr)
    else
      Begin
      CountPoint :=  StrToInt(TempState.Strings[2]) + 1;
      TempState.Strings[2] := IntToStr(CountPoint);
      TempState.Add('0 '+FloatToStrF(X,ffFixed,10,3)+' '+ FloatToStrF(Y,ffFixed,10,3)+' '+FloatToStrF(Z,ffFixed,10,3));
      TempStr := '';
      for i:=0 to TempState.Count -1 do
        TempStr := TempStr + TempState.Strings[i] + NS;
      Connector.SendRStream('Map['+m_MapNumberStr+'].PutObjectCoordinates ' + m_MemberNumberStr + NS + TempStr);
      Add := CountPoint;
      End;
    End;
  FreeAndNil(TempState);
  END;

function  TNPoints.Add(Point:TNPoint):Integer;
  VAR TempState:TStringList;
      CountPoint:Integer;
      i:Integer;
      TempStr:String;
  BEGIN
  TempState := TStringList.Create;
  if m_MapNumber = -1 then
    Begin
    TempState.LoadFromStream(Connector.SendRStream('Map.GetObjectCoordinates '+ m_MemberNumberStr));
    if TempState.Count = 1 then
      raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr +',  ' )
    else
      Begin
      CountPoint :=  StrToInt(TempState.Strings[2]) + 1;
      TempState.Strings[2] := IntToStr(CountPoint);
      TempState.Add('0 '+Point.CoordString);
      TempStr := '';
      for i:=0 to TempState.Count -1 do
        TempStr := TempStr + TempState.Strings[i] + NS;
      Connector.SendRStream('Map.PutObjectCoordinates ' + m_MemberNumberStr + NS + TempStr);
      Add := CountPoint;
      End;
    End
  else
    Begin
    TempState.LoadFromStream(Connector.SendRStream('Map['+m_MapNumberStr+'].GetObjectCoordinates '+ m_MemberNumberStr));
    if TempState.Count = 1 then
      raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr +', : '+m_MapNumberStr)
    else
      Begin
      CountPoint :=  StrToInt(TempState.Strings[2]) + 1;
      TempState.Strings[2] := IntToStr(CountPoint);
      TempState.Add('0 '+Point.CoordString);
      TempStr := '';
      for i:=0 to TempState.Count -1 do
        TempStr := TempStr + TempState.Strings[i] + NS;
      Connector.SendRStream('Map['+m_MapNumberStr+'].PutObjectCoordinates ' + m_MemberNumberStr + NS + TempStr);
      Add := CountPoint;
      End;
    End;
  FreeAndNil(TempState);
  END;

//    
procedure TNPoints.Delete(PointNumber:Integer);
  VAR TempPoint:TNPoint;
  BEGIN
  TempPoint := TNPoint.Create(PointNumber,MemberNumber,MapNumber);
  TempPoint.Delete;
  END;

{===============================================================================
=======================================TNPointList==============================TNPointList
===============================================================================}
function TNPointList.GetPoint(PointNumber:Integer):nPoint;
  VAR TempPoint:pPoint;
      ReplyPoint:nPoint;
  Begin
  if PointNumber > Count then
    raise ENObjectNotExist.Create('     .')
  else
    Begin
     TempPoint := Self[PointNumber - 1];
    ReplyPoint.X := TempPoint.X;
    ReplyPoint.Y := TempPoint.Y;
    ReplyPoint.Z := TempPoint.Z;
    GetPoint := ReplyPoint;
    End;
  End;

procedure TNPointList.AddPoint(mPoint:nPoint);
  VAR TempPoint:pPoint;
  BEGIN
  new(TempPoint);
  TempPoint.X := mPoint.X;
  TempPoint.Y := mPoint.Y;
  TempPoint.Z := mPoint.Z;
  Add(TempPoint);
  END;

procedure TNPointList.AddPoint(X,Y,Z:Double);
  VAR TempPoint:pPoint;
  BEGIN
  new(TempPoint);
  TempPoint.X := X;
  TempPoint.Y := Y;
  TempPoint.Z := Z;
  Add(TempPoint);
  END;

{===============================================================================
=======================================TNMapLayer===============================TNMapLayer
===============================================================================}
constructor TNMapLayer.Create(MemNumber:Integer;MNumber:Integer = -1);
  BEGIN
   inherited Create(MemNumber,MNumber);
   
   m_Parameters := TNLayerParameters.Create(MemNumber,MNumber);
  END;

//LayerType
function TNMapLayer.GetLayerType():nlType;
    VAR TempReply:TStringList;
  BEGIN
  TempReply := TStringList.Create;
  if m_MapNumber = -1 then
    Begin
    TempReply.CommaText :=Connector.SendRStream('Map.Layers.Get '+m_MemberNumberStr).DataString;
    TempReply.Delimiter := #32;
    TempReply.QuoteChar := #0;
    if TempReply.Strings[0] <> '-1' then
      GetLayerType := IntToNLType(StrToInt(TempReply.Strings[1]))
    else
      raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr +',  ' );
    End
  else
    Begin
    TempReply.CommaText :=Connector.SendRStream('Map['+m_MapNumberStr+'].Layers.Get '+m_MemberNumberStr).DataString;
    TempReply.Delimiter := #32;
    TempReply.QuoteChar := #0;
    if TempReply.Strings[0] = '<ERROR>' then
      raise ENObjectNotExist.Create('    ' + m_MapNumberStr)
    else
      if TempReply.Strings[0] <> '-1' then
        GetLayerType := IntToNLType(StrToInt(TempReply.Strings[1]))
      else
        raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr +', : '+ m_MapNumberStr );
    End;

  END;

procedure TNMapLayer.SetLayerType(Value:nlType);
  VAR TempReply: TStringList;
      TempCom:String;
      i:Integer;
  BEGIN
  TempReply := TStringList.Create;
  TempReply.Delimiter := #32;
  TempReply.QuoteChar := #0;

  If m_MapNumber = -1 Then
    Begin
    //  
    TempReply.CommaText := Connector.SendRStream('Map.Layers.Get '+m_MemberNumberStr).DataString;
    if TempReply.Strings[0] <> '-1' then
      Begin
      //  
      TempReply.Strings[1] := IntToStr(NLTypeToInt(Value));
      TempCom := TempReply.Strings[0];
      for i:= 1 to TempReply.Count-1 do
        TempCom := TempCom + #32 + TempReply.strings[i];
      Connector.SendRStream('Map.Layers.Set ' + m_MemberNumberStr + ' ' + TempCom);
      End
    else
      raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr +',  ' );
    End
  Else
    Begin
    //  
    TempReply.CommaText := Connector.SendRStream('Map['+m_MapNumberStr +'].Layers.Get '+m_MemberNumberStr).DataString;
    if TempReply.Strings[0] = '<ERROR>' then
      raise ENObjectNotExist.Create('   t: '+ m_MapNumberStr)
    else
      if TempReply.Strings[0] <> '-1' then
        Begin
        //  
        TempReply.Strings[1] := IntToStr(NLTypeToInt(Value));
        TempCom := TempReply.Strings[0];
        for i:= 1 to TempReply.Count-1 do
          TempCom := TempCom + #32 + TempReply.strings[i];
        Connector.SendRStream('Map['+m_MapNumberStr+'].Layers.Set ' + m_MemberNumberStr + ' ' + TempCom);
        End
      else
        raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr +', : '+ m_MapNumberStr );
    End;
  END;

//==============================================================================
//Code
function TNMapLayer.GetCode():Integer;
    VAR TempReply:TStringList;
  BEGIN
  TempReply := TStringList.Create;
  if m_MapNumber = -1 then
    Begin
    TempReply.CommaText :=Connector.SendRStream('Map.Layers.Get '+m_MemberNumberStr).DataString;
    TempReply.Delimiter := #32;
    TempReply.QuoteChar := #0;
    if TempReply.Strings[0] <> '-1' then
      GetCode := StrToInt(TempReply.Strings[0])
    else
      raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr +',  ' );
    End
  else
    Begin
    TempReply.CommaText :=Connector.SendRStream('Map['+m_MapNumberStr+'].Layers.Get '+m_MemberNumberStr).DataString;
    TempReply.Delimiter := #32;
    TempReply.QuoteChar := #0;
    if TempReply.Strings[0] = '<ERROR>' then
      raise ENObjectNotExist.Create('    ' + m_MapNumberStr)
    else
      if TempReply.Strings[0] <> '-1' then
        GetCode := StrToInt(TempReply.Strings[0])
      else
        raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr +', : '+ m_MapNumberStr );
    End;
  END;

procedure TNMapLayer.SetCode(Value:Integer);
  VAR TempReply: TStringList;
      TempCom:String;
      i:Integer;
  BEGIN
  TempReply := TStringList.Create;
  TempReply.Delimiter := #32;
  TempReply.QuoteChar := #0;

  If m_MapNumber = -1 Then
    Begin
    //  
    TempReply.CommaText := Connector.SendRStream('Map.Layers.Get '+m_MemberNumberStr).DataString;
    if TempReply.Strings[0] <> '-1' then
      Begin
      //  
      TempReply.Strings[0] := IntToStr(Value);
      TempCom := TempReply.Strings[0];
      for i:= 1 to TempReply.Count-1 do
        TempCom := TempCom + #32 + TempReply.strings[i];
      Connector.SendRStream('Map.Layers.Set ' + m_MemberNumberStr + ' ' + TempCom);
      End
    else
      raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr +',  ' );
    End
  Else
    Begin
    //  
    TempReply.CommaText := Connector.SendRStream('Map['+m_MapNumberStr +'].Layers.Get '+m_MemberNumberStr).DataString;
    if TempReply.Strings[0] = '<ERROR>' then
      raise ENObjectNotExist.Create('   t: '+ m_MapNumberStr)
    else
      if TempReply.Strings[0] <> '-1' then
        Begin
        //  
        TempReply.Strings[0] := IntToStr(Value);
        TempCom := TempReply.Strings[0];
        for i:= 1 to TempReply.Count-1 do
          TempCom := TempCom + #32 + TempReply.strings[i];
        Connector.SendRStream('Map['+m_MapNumberStr+'].Layers.Set ' + m_MemberNumberStr + ' ' + TempCom);
        End
      else
        raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr +', : '+ m_MapNumberStr);
    End;
  END;
//==============================================================================
//Name
function TNMapLayer.GetName():String;
    VAR TempReply:TStringList;
        TempName:String;
        i:integer;
  BEGIN
  TempReply := TStringList.Create;
  if m_MapNumber = -1 then
    Begin
    TempReply.CommaText :=Connector.SendRStream('Map.Layers.Get '+m_MemberNumberStr).DataString;
    TempReply.Delimiter := #32;
    TempReply.QuoteChar := #0;
    if TempReply.Strings[0] <> '-1' then
      begin
      TempName := TempReply.Strings[2];
      for i:=3 to TempReply.Count - 1 do
        TempName := TempName + ' ' + TempReply.Strings[i];
      GetName := TempName;
      end
    else
      raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr +',  ' );
    End
  else
    Begin
    TempReply.CommaText :=Connector.SendRStream('Map['+m_MapNumberStr+'].Layers.Get '+m_MemberNumberStr).DataString;
    TempReply.Delimiter := #32;
    TempReply.QuoteChar := #0;
    if TempReply.Strings[0] = '<ERROR>' then
      raise ENObjectNotExist.Create('    ' + m_MapNumberStr)
    else
      if TempReply.Strings[0] <> '-1' then
        begin
       TempName := TempReply.Strings[2];
        for i:=3 to TempReply.Count - 1 do
          TempName := TempName + ' ' + TempReply.Strings[i];
        GetName := TempName;
        end
      else
        raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr +', : '+ m_MapNumberStr );
    End;
  END;

procedure TNMapLayer.SetName(Value:String);
  VAR TempReply: TStringList;
  BEGIN
  TempReply := TStringList.Create;
  TempReply.Delimiter := #32;
  TempReply.QuoteChar := #0;

  If m_MapNumber = -1 Then
    Begin
    //  
    TempReply.CommaText := Connector.SendRStream('Map.Layers.Get '+m_MemberNumberStr).DataString;
    if TempReply.Strings[0] <> '-1' then
      //  
      Connector.SendRStream('Map.Layers.Set ' + m_MemberNumberStr + ' '+ TempReply.Strings[0]+ ' '+ TempReply.Strings[1]+' '+ Value)
    else
      raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr +',  ' );
    End
  Else
    Begin
    //  
    TempReply.CommaText := Connector.SendRStream('Map['+m_MapNumberStr +'].Layers.Get '+m_MemberNumberStr).DataString;
    if TempReply.Strings[0] = '<ERROR>' then
      raise ENObjectNotExist.Create('   t: '+ m_MapNumberStr)
    else
      if TempReply.Strings[0] <> '-1' then
        //  
        Connector.SendRStream('Map['+m_MapNumberStr+'].Layers.Set ' + m_MemberNumberStr + ' '+ TempReply.Strings[0]+ ' '+ TempReply.Strings[1]+' '+ Value)
      else
        raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr +', : '+ m_MapNumberStr );
    End;
  END;

{===============================================================================
=======================================TNObjectLayer============================TNObjectLayer
===============================================================================}
//LayerNumber
function TNObjectLayer.GetLayerNumber():Integer;
  VAR TempReply:TStringList;
  BEGIN
  TempReply := TStringList.Create;
  if m_MapNumber = -1 then
    Begin
    TempReply.LoadFromStream(Connector.SendRStream('Map.GetObjectHeader '+m_MemberNumberStr));
    if TempReply.Count = 1 then
      raise ENObjectNotExist.Create('   : '+ m_MemberNumberStr + ',  ')
    else
      GetLayerNumber := StrToInt(TempReply.Strings[1]);
    End
  else
    Begin
    TempReply.LoadFromStream(Connector.SendRStream('Map['+m_MapNumberStr+'].GetObjectHeader '+m_MemberNumberStr));
    if TempReply.Count = 1 then
      raise ENObjectNotExist.Create('   : '+ m_MemberNumberStr + ', :' + m_MapNumberStr)
    else
      GetLayerNumber := StrToInt(TempReply.Strings[1]);
    End;
  END;

procedure TNObjectLayer.SetLayerNumber(Value:Integer);
  VAR TempLayers:TNMapLayers;
      TempReply:TStringList;
  BEGIN
  TempLayers := TNMapLayers.Create(m_MapNumber);
  TempReply := TStringList.Create;
  if m_MapNumber = -1 then
    Begin
    if Value > TempLayers.Count then
      raise ENObjectNotExist.Create('   : '+ IntToStr(Value) + ', .')
    else
      Begin
      TempReply.LoadFromStream(Connector.SendRStream('Map.GetObjectHeader '+m_MemberNumberStr));
      if TempReply.Count = 1 then
        raise ENObjectNotExist.Create('   : '+ m_MemberNumberStr + ', .')
      else
        Begin
        TempReply.Strings[1] := IntToStr(Value);
        Connector.SendRStream('Map.PutObjectHeader '+m_MemberNumberStr+NS+TempReply.Strings[0]+NS+TempReply.Strings[1]);
        End;
      End;
    End
  else
    Begin
    if Value > TempLayers.Count then
      raise ENObjectNotExist.Create('   : '+ IntToStr(Value) + ', :'+m_MapNumberStr)
    else
      Begin
      TempReply.LoadFromStream(Connector.SendRStream('Map['+m_MapNumberStr+'].GetObjectHeader '+m_MemberNumberStr));
      if TempReply.Count = 1 then
        raise ENObjectNotExist.Create('   : '+ m_MemberNumberStr + ', :' +m_MapNumberStr)
      else
        Begin
        TempReply.Strings[1] := IntToStr(Value);
        Connector.SendRStream('Map['+m_MapNumberStr+'].PutObjectHeader '+m_MemberNumberStr+NS+TempReply.Strings[0]+NS+TempReply.Strings[1]);
        End;
      End;
    End;
  FreeAndNil(TempReply);
  FreeAndNil(TempLayers);
  END;

//Name
function TNObjectLayer.GetName():String;
  VAR TempLayers:TNMapLayers;
  BEGIN
  TempLayers := TNMapLayers.Create(m_MapNumber);
  GetName := TempLayers.GetOfNumber(GetLayerNumber).Name;
  END;

procedure TNObjectLayer.SetName(Value:String);
  VAR TempLayers:TNMapLayers;
  BEGIN
  TempLayers := TNMapLayers.Create(m_MapNumber);
  SetLayerNumber(TempLayers.GetOfName(Value).MemberNumber);
  END;

//LayerType
function TNObjectLayer.GetLayerType():nlType;
  VAR TempLayers:TNMapLayers;
  BEGIN
  TempLayers := TNMapLayers.Create(m_MapNumber);
  GetLayerType := TempLayers.GetOfNumber(GetLayerNumber).LayerType;
  END;

//Code
function TNObjectLayer.GetCode():Integer;
  VAR TempLayers:TNMapLayers;
  BEGIN
  TempLayers := TNMapLayers.Create(m_MapNumber);
  GetCode := TempLayers.GetOfNumber(GetLayerNumber).Code;
  END;

procedure TNObjectLayer.SetCode(Value:Integer);
  VAR TempLayers:TNMapLayers;
  BEGIN
  TempLayers := TNMapLayers.Create(m_MapNumber);
  SetLayerNumber(TempLayers.GetOfCode(Value).MemberNumber);
  END;

{===============================================================================
=======================================TNMapLayers==============================TNMapLayers
===============================================================================}
function TNMapLayers.Add(Code:Integer;Name:String;LayerType:nlType):Integer;
  VAR TempCom:String;
  BEGIN
  if m_MapNumber = -1 then
    begin
    TempCom := Connector.SendRStream('Map.Layers.Add '+IntToStr(Code)+' '+ IntToStr(NLTypeToInt(LayerType))+' '+Name).DataString;
    Add := StrToInt(TempCom);
    end
  else
    begin
    TempCom := Connector.SendRStream('Map['+m_MapNumberStr+'].Layers.Add '+IntToStr(Code)+' '+ IntToStr(NLTypeToInt(LayerType))+' '+Name).DataString;
    if TempCom[1] = '<' then
      raise ENObjectNotExist.Create('   :' + m_MapNumberStr)
    else
      Add := StrToInt(TempCom);
    end;
  END;

function  TNMapLayers.Add(MapLayer:TNMapLayer):Integer;
  VAR TempCom:String;
  BEGIN
  if m_MapNumber = -1 then
    begin
    TempCom := Connector.SendRStream('Map.Layers.Add '+IntToStr(MapLayer.Code)+' '+ IntToStr(NLTypeToInt(MapLayer.LayerType))+' '+MapLayer.Name).DataString;
    Add := StrToInt(TempCom);
    end
  else
    begin
    TempCom := Connector.SendRStream('Map['+m_MapNumberStr+'].Layers.Add '+IntToStr(MapLayer.Code)+' '+ IntToStr(NLTypeToInt(MapLayer.LayerType))+' '+MapLayer.Name).DataString;
    if TempCom[1] = '<' then
      raise ENObjectNotExist.Create('   :' + m_MapNumberStr)
    else
      Add := StrToInt(TempCom);
    end;
  END;

function TNMapLayers.GetCount():Integer;
  VAR TempReply:TStringList;
      FirstStr:String;
  BEGIN
  TempReply := TStringList.Create;
  if m_MapNumber = -1 then
    Begin
    TempReply.LoadFromStream(Connector.SendRStream('Map.Layers.List'));
    GetCount := TempReply.Count;
    End
  else
    Begin
    TempReply.LoadFromStream(Connector.SendRStream('Map['+m_MapNumberStr+'].Layers.List'));
    FirstStr := TempReply[0];
    if FirstStr[1] = '<' then
      raise ENObjectNotExist.Create('   :' + m_MapNumberStr)
    else
      GetCount := TempReply.Count;
    End;
  FreeAndNil(TempReply);
  END;

function TNMapLayers.GetOfNumber(Number:Integer):TNMapLayer;
  VAR TempReply:TStringList;
      FirstStr:String;
  BEGIN
  TempReply := TStringList.Create;
  if m_MapNumber = -1 then
    Begin
    TempReply.LoadFromStream(Connector.SendRStream('Map.Layers.List'));
    if Number > TempReply.Count then
      raise ENObjectNotExist.Create('   :' + IntToStr(Number)+ '  ')
    else
      GetOfNumber := TNMapLayer.Create(Number,m_MapNumber);
    End
  else
    Begin
    TempReply.LoadFromStream(Connector.SendRStream('Map['+m_MapNumberStr+'].Layers.List'));
    FirstStr := TempReply[0];
    if FirstStr[1] = '<' then
      raise ENObjectNotExist.Create('   : ' + m_MapNumberStr)
    else
      if Number > TempReply.Count then
        raise ENObjectNotExist.Create('   :' + IntToStr(Number)+ ' : '+ m_MapNumberStr)
      else
        GetOfNumber := TNMapLayer.Create(Number,m_MapNumber);
    End;
  FreeAndNil(TempReply);
  END;

function TNMapLayers.GetOfCode(Code:Integer):TNMapLayer;
  VAR TempReply:TStringList;
      TempLayer:TNMapLayer;
      i:Integer;
      TempCode:String;
      FirstStr:String;
  BEGIN
  TempReply := TStringList.Create;
  TempLayer := nil;
  i:=0;
  if m_MapNumber = -1 then
    Begin
    TempReply.LoadFromStream(Connector.SendRStream('Map.Layers.List'));
    While i<TempReply.Count  do
      Begin
      TempCode := copy(TempReply.Strings[i],1,Pos(' ',TempReply.Strings[i])-1);
      if TempCode = IntToStr(Code) then
        Begin
        TempLayer := TNMapLayer.Create(i+1,m_MapNumber);
        Break;
        End;
      inc(i);
      End;
    if TempLayer = nil then
      Raise ENObjectNotExist.Create('     :' + IntToStr(Code)+ '  ');
    End
  else
    Begin
    TempReply.LoadFromStream(Connector.SendRStream('Map['+m_MapNumberStr+'].Layers.List'));
    FirstStr := TempReply.Strings[0];
    if FirstStr[1] = '<' then
      raise ENObjectNotExist.Create('   :'+ m_MapNumberStr)
    else
      Begin
      While i<TempReply.Count  do
        Begin
        TempCode := copy(TempReply.Strings[i],1,Pos(' ',TempReply.Strings[i])-1);
        if TempCode = IntToStr(Code) then
          Begin
          TempLayer := TNMapLayer.Create(i+1,m_MapNumber);
          Break;
          End;
        inc(i);
        End;
      if TempLayer = nil then
        Raise ENObjectNotExist.Create('     :' + IntToStr(Code)+ ' :'+m_MapNumberStr);
      End;
    End;
   GetOfCode := TempLayer;
   FreeAndNil(TempReply);
  END;

function TNMapLayers.GetOfName(Name:String):TNMapLayer;
  VAR TempReply:TStringList;
      TempLayer:TNMapLayer;
      i:Integer;
      TempName:String;
      FirstStr:String;
  BEGIN
  TempReply := TStringList.Create;
  TempLayer := nil;
  i:=0;
  if m_MapNumber = -1 then
    Begin
    TempReply.LoadFromStream(Connector.SendRStream('Map.Layers.List'));
    While i<TempReply.Count  do
      Begin
      TempName := copy(TempReply.Strings[i],Pos(' ',TempReply.Strings[i])+1,Length(TempReply.Strings[i]));
      if TempName = Name then
        Begin
        TempLayer := TNMapLayer.Create(i+1,m_MapNumber);
        Break;
        End;
      inc(i);
      End;
    if TempLayer = nil then
      Raise ENObjectNotExist.Create('     :' +Name + ',  ');
    End
  else
    Begin
    TempReply.LoadFromStream(Connector.SendRStream('Map['+m_MapNumberStr+'].Layers.List'));
    FirstStr := TempReply.Strings[0];
    if FirstStr[1] = '<' then
      raise ENObjectNotExist.Create('   :'+ m_MapNumberStr)
    else
      Begin
      While i<TempReply.Count  do
        Begin
        TempName := copy(TempReply.Strings[i],Pos(' ',TempReply.Strings[i])+1,Length(TempReply.Strings[i]));
        if TempName  = Name  then
          Begin
          TempLayer := TNMapLayer.Create(i+1,m_MapNumber);
          Break;
          End;
        inc(i);
        End;
      if TempLayer = nil then
        Raise ENObjectNotExist.Create('     :' + Name + ', :'+m_MapNumberStr);
      End;
    End;
   GetOfName := TempLayer;
   FreeAndNil(TempReply);
  END;

{===============================================================================
=======================================TNMapParameter==========================TNMapParameter
===============================================================================}
//ParameterType
function TNMapParameter.GetParameterType():npType;
    VAR TempReply:TStringList;
  BEGIN
  TempReply := TStringList.Create;
  if m_MapNumber = -1 then
    Begin
    TempReply.CommaText :=Connector.SendRStream('Map.Parameters.Get '+m_MemberNumberStr).DataString;
    TempReply.Delimiter := #32;
    TempReply.QuoteChar := #0;
    if TempReply.Strings[0] <> '-1' then
      GetParameterType := IntToNPType(StrToInt(TempReply.Strings[1]))
    else
      raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr +',  ' );
    End
  else
    Begin
    TempReply.CommaText :=Connector.SendRStream('Map['+m_MapNumberStr+'].Parameters.Get '+m_MemberNumberStr).DataString;
    TempReply.Delimiter := #32;
    TempReply.QuoteChar := #0;
    if TempReply.Strings[0] = '<ERROR>' then
      raise ENObjectNotExist.Create('    ' + m_MapNumberStr)
    else
      if TempReply.Strings[0] <> '-1' then
        GetParameterType := IntToNPType(StrToInt(TempReply.Strings[1]))
      else
        raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr +', : '+ m_MapNumberStr );
    End;
  END;

procedure TNMapParameter.SetParameterType(Value:npType);
  VAR TempReply: TStringList;
      TempCom:String;
      i:Integer;
  BEGIN
  TempReply := TStringList.Create;
  TempReply.Delimiter := #32;
  TempReply.QuoteChar := #0;

  If m_MapNumber = -1 Then
    Begin
    //  
    TempReply.CommaText := Connector.SendRStream('Map.Parameters.Get '+m_MemberNumberStr).DataString;
    if TempReply.Strings[0] <> '-1' then
      Begin
      //  
      TempReply.Strings[1] := IntToStr(NPTypeToInt(Value));
      TempCom := TempReply.Strings[0];
      for i:= 1 to TempReply.Count-1 do
        TempCom := TempCom + #32 + TempReply.strings[i];
      Connector.SendRStream('Map.Parameters.Set ' + m_MemberNumberStr + ' ' + TempCom);
      End
    else
      raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr +',  ' );
    End
  Else
    Begin
    //  
    TempReply.CommaText := Connector.SendRStream('Map['+m_MapNumberStr +'].Parameters.Get '+m_MemberNumberStr).DataString;
    if TempReply.Strings[0] = '<ERROR>' then
      raise ENObjectNotExist.Create('   t: '+ m_MapNumberStr)
    else
      if TempReply.Strings[0] <> '-1' then
        Begin
        //  
        TempReply.Strings[1] := IntToStr(NPTypeToInt(Value));
        TempCom := TempReply.Strings[0];
        for i:= 1 to TempReply.Count-1 do
          TempCom := TempCom + #32 + TempReply.strings[i];
        Connector.SendRStream('Map['+m_MapNumberStr+'].Parameters.Set ' + m_MemberNumberStr + ' ' + TempCom);
        End
      else
        raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr +', : '+ m_MapNumberStr );
    End;
  END;

//Name
function TNMapParameter.GetName():String;
    VAR TempReply:TStringList;
        TempName:String;
        i:integer;
  BEGIN
  TempReply := TStringList.Create;
  if m_MapNumber = -1 then
    Begin
    TempReply.CommaText :=Connector.SendRStream('Map.Parameters.Get '+m_MemberNumberStr).DataString;
    TempReply.Delimiter := #32;
    TempReply.QuoteChar := #0;
    if TempReply.Strings[0] <> '-1' then
      begin
      TempName := TempReply.Strings[2];
      for i:=3 to TempReply.Count - 1 do
        TempName := TempName + ' ' + TempReply.Strings[i];
      GetName := TempName;
      end
    else
      raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr +',  ' );
    End
  else
    Begin
    TempReply.CommaText :=Connector.SendRStream('Map['+m_MapNumberStr+'].Parameters.Get '+m_MemberNumberStr).DataString;
    TempReply.Delimiter := #32;
    TempReply.QuoteChar := #0;
    if TempReply.Strings[0] = '<ERROR>' then
      raise ENObjectNotExist.Create('    ' + m_MapNumberStr)
    else
      if TempReply.Strings[0] <> '-1' then
        begin
       TempName := TempReply.Strings[2];
        for i:=3 to TempReply.Count - 1 do
          TempName := TempName + ' ' + TempReply.Strings[i];
        GetName := TempName;
        end
      else
        raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr +', : '+ m_MapNumberStr );
    End;
  END;

procedure TNMapParameter.SetName(Value:String);
  VAR TempReply: TStringList;
  BEGIN
  TempReply := TStringList.Create;
  TempReply.Delimiter := #32;
  TempReply.QuoteChar := #0;

  If m_MapNumber = -1 Then
    Begin
    //  
    TempReply.CommaText := Connector.SendRStream('Map.Parameters.Get '+m_MemberNumberStr).DataString;
    if TempReply.Strings[0] <> '-1' then
      //  
      Connector.SendRStream('Map.Parameters.Set ' + m_MemberNumberStr + ' '+ TempReply.Strings[0]+ ' '+ TempReply.Strings[1]+' '+ Value)
    else
      raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr +',  ' );
    End
  Else
    Begin
    //  
    TempReply.CommaText := Connector.SendRStream('Map['+m_MapNumberStr +'].Parameters.Get '+m_MemberNumberStr).DataString;
    if TempReply.Strings[0] = '<ERROR>' then
      raise ENObjectNotExist.Create('   : '+ m_MapNumberStr)
    else
      if TempReply.Strings[0] <> '-1' then
        //  
        Connector.SendRStream('Map['+m_MapNumberStr+'].Parameters.Set ' + m_MemberNumberStr + ' '+ TempReply.Strings[0]+ ' '+ TempReply.Strings[1]+' '+ Value)
      else
        raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr +', : '+ m_MapNumberStr );
    End;
  END;

//Code
function TNMapParameter.GetCode():Integer;
    VAR TempReply:TStringList;
  BEGIN
  TempReply := TStringList.Create;
  if m_MapNumber = -1 then
    Begin
    TempReply.CommaText :=Connector.SendRStream('Map.Parameters.Get '+m_MemberNumberStr).DataString;
    TempReply.Delimiter := #32;
    TempReply.QuoteChar := #0;
    if TempReply.Strings[0] <> '-1' then
      GetCode := StrToInt(TempReply.Strings[0])
    else
      raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr +',  ' );
    End
  else
    Begin
    TempReply.CommaText :=Connector.SendRStream('Map['+m_MapNumberStr+'].Parameters.Get '+m_MemberNumberStr).DataString;
    TempReply.Delimiter := #32;
    TempReply.QuoteChar := #0;
    if TempReply.Strings[0] = '<ERROR>' then
      raise ENObjectNotExist.Create('    ' + m_MapNumberStr)
    else
      if TempReply.Strings[0] <> '-1' then
        GetCode := StrToInt(TempReply.Strings[0])
      else
        raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr +', : '+ m_MapNumberStr );
    End;
  END;

procedure TNMapParameter.SetCode(Value:Integer);
  VAR TempReply: TStringList;
      TempCom:String;
      i:Integer;
  BEGIN
  TempReply := TStringList.Create;
  TempReply.Delimiter := #32;
  TempReply.QuoteChar := #0;

  If m_MapNumber = -1 Then
    Begin
    //  
    TempReply.CommaText := Connector.SendRStream('Map.Parameters.Get '+m_MemberNumberStr).DataString;
    if TempReply.Strings[0] <> '-1' then
      Begin
      //  
      TempReply.Strings[0] := IntToStr(Value);
      TempCom := TempReply.Strings[0];
      for i:= 1 to TempReply.Count-1 do
        TempCom := TempCom + #32 + TempReply.strings[i];
      Connector.SendRStream('Map.Parameters.Set ' + m_MemberNumberStr + ' ' + TempCom);
      End
    else
      raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr +',  ' );
    End
  Else
    Begin
    //  
    TempReply.CommaText := Connector.SendRStream('Map['+m_MapNumberStr +'].Parameters.Get '+m_MemberNumberStr).DataString;
    if TempReply.Strings[0] = '<ERROR>' then
      raise ENObjectNotExist.Create('   t: '+ m_MapNumberStr)
    else
      if TempReply.Strings[0] <> '-1' then
        Begin
        //  
        TempReply.Strings[0] := IntToStr(Value);
        TempCom := TempReply.Strings[0];
        for i:= 1 to TempReply.Count-1 do
          TempCom := TempCom + #32 + TempReply.strings[i];
        Connector.SendRStream('Map['+m_MapNumberStr+'].Parameters.Set ' + m_MemberNumberStr + ' ' + TempCom);
        End
      else
        raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr +', : '+ m_MapNumberStr);
    End;
  END;

{===============================================================================
======================================TNMapParameters==========================TNMapParameters
===============================================================================}
function TNMapParameters.Add(Code:Integer;Name:String;ParameterType:npType):Integer;
  VAR TempCom:String;
  BEGIN
  if m_MapNumber = -1 then
    begin
    TempCom := Connector.SendRStream('Map.Parameters.Add '+IntToStr(Code)+' '+ IntToStr(NPTypeToInt(ParameterType))+' '+Name).DataString;
    Add := StrToInt(TempCom);
    end
  else
    begin
    TempCom := Connector.SendRStream('Map['+m_MapNumberStr+'].Parameters.Add '+IntToStr(Code)+' '+ IntToStr(NPTypeToInt(ParameterType))+' '+Name).DataString;
    if TempCom[1] = '<' then
      raise ENObjectNotExist.Create('   :' + m_MapNumberStr)
    else
      Add := StrToInt(TempCom);
    end;
  END;

function TNMapParameters.Add(MapParameter:TNMapParameter):Integer;
  VAR TempCom:String;
  BEGIN
  if m_MapNumber = -1 then
    begin
    TempCom := Connector.SendRStream('Map.Parameters.Add '+IntToStr(MapParameter.Code)+' '+ IntToStr(NPTypeToInt(MapParameter.ParameterType))+' '+MapParameter.Name).DataString;
    Add := StrToInt(TempCom);
    end
  else
    begin
    TempCom := Connector.SendRStream('Map['+m_MapNumberStr+'].Parameters.Add '+IntToStr(MapParameter.Code)+' '+ IntToStr(NPTypeToInt(MapParameter.ParameterType))+' '+MapParameter.Name).DataString;
    if TempCom[1] = '<' then
      raise ENObjectNotExist.Create('   :' + m_MapNumberStr)
    else
      Add := StrToInt(TempCom);
    end;
  END;

//------------------------------------------------------------------------------
//GetOfNumber
function TNMapParameters.GetOfNumber(Number:Integer):TNMapParameter;
  VAR TempReply:TStringList;
      FirstStr:String;
  BEGIN
  TempReply := TStringList.Create;
  if m_MapNumber = -1 then
    Begin
    TempReply.LoadFromStream(Connector.SendRStream('Map.Parameters.List'));
    if Number > TempReply.Count then
      raise ENObjectNotExist.Create('   :' + IntToStr(Number)+ '  ')
    else
      GetOfNumber := TNMapParameter.Create(Number,m_MapNumber);
    End
  else
    Begin
    TempReply.LoadFromStream(Connector.SendRStream('Map['+m_MapNumberStr+'].Parameters.List'));
    FirstStr := TempReply[0];
    if FirstStr[1] = '<' then
      raise ENObjectNotExist.Create('   : ' + m_MapNumberStr)
    else
      if Number > TempReply.Count then
        raise ENObjectNotExist.Create('   :' + IntToStr(Number)+ ' : '+ m_MapNumberStr)
      else
        GetOfNumber := TNMapParameter.Create(Number,m_MapNumber);
    End;
  FreeAndNil(TempReply);
  END;

//------------------------------------------------------------------------------
//GetOfCode
function TNMapParameters.GetOfCode(Code:Integer):TNMapParameter;
  VAR TempReply:TStringList;
      TempParam:TNMapParameter;
      i:Integer;
      TempCode:String;
      FirstStr:String;
  BEGIN
  TempReply := TStringList.Create;
  TempParam := nil;
  i:=0;
  if m_MapNumber = -1 then
    Begin
    TempReply.LoadFromStream(Connector.SendRStream('Map.Parameters.List'));
    While i<TempReply.Count  do
      Begin
      TempCode := copy(TempReply.Strings[i],1,Pos(' ',TempReply.Strings[i])-1);
      if TempCode = IntToStr(Code) then
        Begin
        TempParam := TNMapParameter.Create(i+1,m_MapNumber);
        Break;
        End;
      inc(i);
      End;
    if TempParam = nil then
      Raise ENObjectNotExist.Create('     :' + IntToStr(Code)+ '  ');
    End
  else
    Begin
    TempReply.LoadFromStream(Connector.SendRStream('Map['+m_MapNumberStr+'].Parameters.List'));
    FirstStr := TempReply.Strings[0];
    if FirstStr[1] = '<' then
      raise ENObjectNotExist.Create('   :'+ m_MapNumberStr)
    else
      Begin
      While i<TempReply.Count  do
        Begin
        TempCode := copy(TempReply.Strings[i],1,Pos(' ',TempReply.Strings[i])-1);
        if TempCode = IntToStr(Code) then
          Begin
          TempParam := TNMapParameter.Create(i+1,m_MapNumber);
          Break;
          End;
        inc(i);
        End;
      if TempParam = nil then
        Raise ENObjectNotExist.Create('     :' + IntToStr(Code)+ ' :'+m_MapNumberStr);
      End;
    End;
   GetOfCode := TempParam;
   FreeAndNil(TempReply);
  END;

function TNMapParameters.GetOfName(Name:String):TNMapParameter;
  VAR TempReply:TStringList;
      TempParam:TNMapParameter;
      i:Integer;
      TempName:String;
      FirstStr:String;
  BEGIN
  TempReply := TStringList.Create;
  TempParam := nil;
  i:=0;
  if m_MapNumber = -1 then
    Begin
    TempReply.LoadFromStream(Connector.SendRStream('Map.Parameters.List'));
    While i<TempReply.Count  do
      Begin
      TempName := copy(TempReply.Strings[i],Pos(' ',TempReply.Strings[i])+1,Length(TempReply.Strings[i]));
      if TempName = Name then
        Begin
        TempParam := TNMapParameter.Create(i+1,m_MapNumber);
        Break;
        End;
      inc(i);
      End;
    if TempParam = nil then
      Raise ENObjectNotExist.Create('     :' +Name + ',  ');
    End
  else
    Begin
    TempReply.LoadFromStream(Connector.SendRStream('Map['+m_MapNumberStr+'].Parameters.List'));
    FirstStr := TempReply.Strings[0];
    if FirstStr[1] = '<' then
      raise ENObjectNotExist.Create('   :'+ m_MapNumberStr)
    else
      Begin
      While i<TempReply.Count  do
        Begin
        TempName := copy(TempReply.Strings[i],Pos(' ',TempReply.Strings[i])+1,Length(TempReply.Strings[i]));
        if TempName  = Name  then
          Begin
          TempParam := TNMapParameter.Create(i+1,m_MapNumber);
          Break;
          End;
        inc(i);
        End;
      if TempParam = nil then
        Raise ENObjectNotExist.Create('     :' + Name + ', :'+m_MapNumberStr);
      End;
    End;
   GetOfName := TempParam;
   FreeAndNil(TempReply);
  END;

function TNMapParameters.GetCount():Integer;
  VAR TempReply:TStringList;
      FirstStr:String;
  BEGIN
  TempReply := TStringList.Create;
  if m_MapNumber = -1 then
    Begin
    TempReply.LoadFromStream(Connector.SendRStream('Map.Parameters.List'));
    GetCount := TempReply.Count;
    End
  else
    Begin
    TempReply.LoadFromStream(Connector.SendRStream('Map['+m_MapNumberStr+'].Parameters.List'));
    FirstStr := TempReply[0];
    if FirstStr[1] = '<' then
      raise ENObjectNotExist.Create('   :' + m_MapNumberStr)
    else
      GetCount := TempReply.Count;
    End;
  FreeAndNil(TempReply);
  END;

{===============================================================================
======================================TNLayerParameter==========================TNLayerParameter
===============================================================================}
constructor TNLayerParameter.Create(ParamNumber:Integer; LayerNumber:Integer;MNumber:Integer = -1);
  BEGIN
    inherited Create(LayerNumber,MNumber);

    m_Number := ParamNumber;
    m_NumberStr := IntToStr(ParamNumber);
  END;

//Code
function TNLayerParameter.GetCode():Integer;
  VAR TempParam:TNMapParameter;
  BEGIN
  TempParam := TNMapParameter.Create(m_Number,m_MapNumber);
  GetCode := TempParam.GetCode;
  END;

//Type
function TNLayerParameter.GetType():npType;
  VAR TempParam:TNMapParameter;
  BEGIN
  TempParam := TNMapParameter.Create(m_Number,m_MapNumber);
  GetType := TempParam.GetParameterType;
  END;

//Name
function TNLayerParameter.GetName():String;
  VAR TempParam:TNMapParameter;
  BEGIN
  TempParam := TNMapParameter.Create(m_Number,m_MapNumber);
  GetName := TempParam.GetName;
  END;


{===============================================================================
======================================TNLayerParameters=========================TNLayerParameters
===============================================================================}
constructor TNLayerParameters.Create(LayerNumber:Integer;MNumber:Integer = -1);
  BEGIN
    inherited Create(MNumber);

    m_MemberNumber := LayerNumber;
    m_MemberNumberStr := IntToStr(LayerNumber);
  END;

//------------------------------------------------------------------------------
//GetCount
function TNLayerParameters.GetCount():Integer;
  VAR TempReply:TStringList;
  BEGIN
  TempReply := TStringList.Create;
  TempReply.Delimiter := ' ';
  if m_MapNumber = -1 then
    Begin
    TempReply.CommaText := Connector.SendRStream('Map.Layers.GetValidParameters '+ m_MemberNumberStr).DataString;
    GetCount := TempReply.Count - 1;
    End
  Else
    Begin
    TempReply.CommaText := Connector.SendRStream('Map['+m_MapNumberStr+'].Layers.GetValidParameters '+ m_MemberNumberStr).DataString;
    if TempReply.Strings[0] = '<ERROR>' then
      raise ENObjectNotExist.Create('   : ' + m_MapNumberStr)
    else
      GetCount := TempReply.Count - 1;
    End;
  FreeAndNil(TempReply);
  END;


//------------------------------------------------------------------------------
//AddParameter
procedure TNLayerParameters.AddParameter(MapParameter:TNMapParameter);
  VAR TempReply:TStringList;
      i:Integer;
      Com:String;
  BEGIN
  TempReply := TStringList.Create;
  TempReply.Delimiter := ' ';
  if m_MapNumber = -1 then
    Begin
    TempReply.CommaText := Connector.SendRStream('Map.Layers.GetValidParameters '+ m_MemberNumberStr).DataString;
    Com := 'Map.Layers.SetValidParameters '+ m_MemberNumberStr;
    for i:= 1 to TempReply.Count-1 do
      if MapParameter.MemberNumber = StrToInt(TempReply.Strings[i]) then
        raise ENAddRepeatObject.Create(': ' + m_MemberNumberStr + '     : "'+ MapParameter.Name+'"')
      else
        Com := Com + ' ' + TempReply.Strings[i];

    Com := Com + ' ' + IntToStr(MapParameter.MemberNumber);
    Connector.SendRStream(Com);
    End
  Else
    Begin
    TempReply.CommaText := Connector.SendRStream('Map['+m_MapNumberStr+'].Layers.GetValidParameters '+ m_MemberNumberStr).DataString;
    if TempReply.Strings[0] = '<ERROR>' then
      raise ENObjectNotExist.Create('   : ' + m_MapNumberStr)
    else
      Begin
      Com := 'Map['+m_MapNumberStr+'].Layers.SetValidParameters '+ m_MemberNumberStr;
      for i:= 1 to TempReply.Count-1 do
        if MapParameter.MemberNumber = StrToInt(TempReply.Strings[i]) then
          raise ENAddRepeatObject.Create(': ' + m_MemberNumberStr + '  : ' + m_MapNumberStr  + '   : "'+ MapParameter.Name+'"')
        else
          Com := Com + ' ' + TempReply.Strings[i];

      Com := Com + ' ' + IntToStr(MapParameter.MemberNumber);
      Connector.SendRStream(Com);
      End;
    End;
  FreeAndNil(TempReply);
  END;

procedure TNLayerParameters.DeleteParameter(MapParameter:TNMapParameter);
  VAR TempReply:TStringList;
      i:Integer;
      Com:String;
  BEGIN
  TempReply := TStringList.Create;
  TempReply.Delimiter := ' ';
  if m_MapNumber = -1 then
    Begin
    TempReply.CommaText := Connector.SendRStream('Map.Layers.GetValidParameters '+ m_MemberNumberStr).DataString;
    Com := 'Map.Layers.SetValidParameters '+ m_MemberNumberStr;
    for i:= 1 to TempReply.Count-1 do
      if MapParameter.MemberNumber <> StrToInt(TempReply.Strings[i]) then
        Com := Com + ' ' + TempReply.Strings[i];

    Connector.SendRStream(Com);
    End
  Else
    Begin
    TempReply.CommaText := Connector.SendRStream('Map['+m_MapNumberStr+'].Layers.GetValidParameters '+ m_MemberNumberStr).DataString;
    if TempReply.Strings[0] = '<ERROR>' then
      raise ENObjectNotExist.Create('   : ' + m_MapNumberStr)
    else
      Begin
      Com := 'Map['+m_MapNumberStr+'].Layers.SetValidParameters '+ m_MemberNumberStr;
      for i:= 1 to TempReply.Count-1 do
        if MapParameter.MemberNumber <> StrToInt(TempReply.Strings[i]) then
          Com := Com + ' ' + TempReply.Strings[i];

      Connector.SendRStream(Com);
      End;
    End;
  FreeAndNil(TempReply);
  END;

//GetOfNumber
function TNLayerParameters.GetOfNumber(NumberOfList:Integer):TNLayerParameter;
  VAR TempReply:TStringList;
  BEGIN
  TempReply := TStringList.Create;
  TempReply.Delimiter := ' ';
  if m_MapNumber = -1 then
    Begin
    TempReply.CommaText := Connector.SendRStream('Map.Layers.GetValidParameters '+ m_MemberNumberStr).DataString;
    if NumberOfList > TempReply.Count - 2 then
      raise ENObjectNotExist.Create('   : '+ IntToStr(NumberOfList) + ', : ' + m_MemberNumberStr + ',  .')
    else
      GetOfNumber := TNLayerParameter.Create(StrToInt(TempReply.Strings[NumberOfList+1]),m_MapNumber);
    End
  Else
    Begin
    TempReply.CommaText := Connector.SendRStream('Map['+m_MapNumberStr+'].Layers.GetValidParameters '+ m_MemberNumberStr).DataString;
    if TempReply.Strings[0] = '<ERROR>' then
      raise ENObjectNotExist.Create('   : ' + m_MapNumberStr)
    else
      Begin
      if NumberOfList > TempReply.Count - 2 then
        raise ENObjectNotExist.Create('   : '+ IntToStr(NumberOfList) + ', : ' + m_MemberNumberStr + ',  .')
      else
        GetOfNumber := TNLayerParameter.Create(StrToInt(TempReply.Strings[NumberOfList+1]),m_MapNumber);
      End;
    End;
  FreeAndNil(TempReply);
  END;

{===============================================================================
======================================TNObjectParameter=========================TNObjectParameter
===============================================================================}
constructor TNObjectParameter.Create(ParamNumber:Integer; MemNumber:Integer; MNumber:Integer = -1);
  BEGIN
    inherited Create(MemNumber,MNumber);

    m_Number := ParamNumber;
    m_NumberStr := IntToStr(ParamNumber);
  END;

//------------------------------------------------------------------------------
//Name
function TNObjectParameter.GetName():String;
  VAR TempParam:TNMapParameter;
  BEGIN
  TempParam := TNMapParameter.Create(m_Number,m_MapNumber);
  GetName := TempParam.Name;
  FreeAndNil(TempParam);
  END;

//------------------------------------------------------------------------------
//Code
function TNObjectParameter.GetCode():Integer;
  VAR TempParam:TNMapParameter;
  BEGIN
  TempParam := TNMapParameter.Create(m_Number,m_MapNumber);
  GetCode := TempParam.Code;
  FreeAndNil(TempParam);
  END;

//------------------------------------------------------------------------------
//ParameterType
function TNObjectParameter.GetType():npType;
  VAR TempParam:TNMapParameter;
  BEGIN
  TempParam := TNMapParameter.Create(m_Number,m_MapNumber);
  GetType := TempParam.ParameterType;
  FreeAndNil(TempParam);
  END;
//------------------------------------------------------------------------------
//Value
function TNObjectParameter.GetValue():String;
  VAR ReplyList:TStringList;
      ReplyStr:String;
  BEGIN
  ReplyList := TStringList.Create;
  if m_MapNumber = -1 then
    begin
    ReplyStr := Connector.SendRStream('Map.Object['+m_MemberNumberStr+'].Parameter['+m_NumberStr+']').DataString;
    ReplyList.Delimiter := ' ';
    ReplyList.CommaText := ReplyStr;
    if ReplyList.Strings[0] = '<ERROR>' then
      raise ENObjectNotExist.Create('   : ' + m_NumberStr +  ', : ' + m_MemberNumberStr +',  .' )
    else
      GetValue := ReplyStr;
    end
  else
    begin
    ReplyStr := Connector.SendRStream('Map['+m_MapNumberStr+'].Object['+m_MemberNumberStr+'].Parameter['+m_NumberStr+']').DataString;
    ReplyList.Delimiter := ' ';
    ReplyList.CommaText := ReplyStr;
    if ReplyList.Strings[0] = '<ERROR>' then
      raise ENObjectNotExist.Create('   : ' + m_NumberStr +  ', : ' + m_MemberNumberStr +', : ' + m_MapNumberStr)
    else
      GetValue := ReplyStr;
    end;
  FreeAndNil(ReplyList);
  END;

procedure TNObjectParameter.SetValue(mValue:String);
  VAR ReplyStr:String;
  BEGIN
  if m_MapNumber = -1 then
    begin
    ReplyStr := Connector.SendRStream('Map.Object['+m_MemberNumberStr+'].Parameter['+m_NumberStr+'] '+ mValue).DataString;
    if ReplyStr <> mValue then
      raise ENObjectNotExist.Create('   : ' + m_NumberStr +  ', : ' + m_MemberNumberStr +',  .' );
    end
  else
    begin
    ReplyStr := Connector.SendRStream('Map['+m_MapNumberStr+'].Object['+m_MemberNumberStr+'].Parameter['+m_NumberStr+'] ' + mValue).DataString;
    if ReplyStr <> mValue then
      raise ENObjectNotExist.Create('   : ' + m_NumberStr +  ', : ' + m_MemberNumberStr +', : ' + m_MapNumberStr);
    end;
  END;

{===============================================================================
======================================TNObjectParameters========================TNObjectParameters
===============================================================================}
constructor TNObjectParameters.Create(ObjectNumber:Integer;MNumber:Integer=-1);
  BEGIN
    inherited Create(MNumber);

    m_MemberNumber := ObjectNumber;
    m_MemberNumberStr := IntToStr(m_MemberNumber);
  END;

//------------------------------------------------------------------------------
//GetCount
function TNObjectParameters.GetCount():Integer;
  VAR TempReply:TStringList;
      FirstStr:String;
  BEGIN
  TempReply := TStringList.Create;
  if m_MapNumber = -1 then
    Begin
    TempReply.LoadFromStream(Connector.SendRStream('Map.GetObjectParameters '+ m_MemberNumberStr));
    FirstStr := TempReply.Strings[0];
    if FirstStr[1] = '<' then
      raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr + ',  .')
    else
      GetCount := TempReply.Count - 3;
    End
  Else
    Begin
    TempReply.LoadFromStream(Connector.SendRStream('Map['+m_MapNumberStr+'].GetObjectParameters '+ m_MemberNumberStr));
    FirstStr := TempReply.Strings[0];
    if FirstStr[1] = '<' then
      raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr + ', : '+ m_MapNumberStr)
    else
      GetCount := TempReply.Count - 3;
    End;
  FreeAndNil(TempReply);
  END;

//GetOfNumber
function TNObjectParameters.GetOfNumber(NumberOfList:Integer):TNObjectParameter;
  VAR Reply:TStringList;
      ParamVal:TStringList;
      FirstString:String;
  BEGIN
  Reply := TStringList.Create;
  ParamVal := TStringList.Create;
  ParamVal.Delimiter := ' ';
  if m_MapNumber = -1 then
    begin
    Reply.LoadFromStream(Connector.SendRStream('Map.GetObjectParameters '+ m_MemberNumberStr));
    FirstString := Reply.Strings[0];
    if FirstString[1] = '<' then
      raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr + ',  ')
    else
      if NumberOfList > Reply.Count - 3 then
        raise ENObjectNotExist.Create('   : ' + IntToStr(NumberOfList) + ', : ' + m_MemberNumberStr + ',  ')
      else
        Begin
        ParamVal.CommaText := Reply.Strings[NumberOfList+2];
        GetOfNumber := TNObjectParameter.Create(StrToInt(ParamVal.Strings[0]),m_MemberNumber,m_MapNumber);
        End;
    end
  else
    begin
    Reply.LoadFromStream(Connector.SendRStream('Map[' + m_MapNumberStr + '].GetObjectParameters ' + m_MemberNumberStr));
    FirstString := Reply.Strings[0];
    if FirstString[1] = '<' then
      raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr + ', : ' + m_MapNumberStr)
    else
      if NumberOfList > Reply.Count - 3 then
        raise ENObjectNotExist.Create('   : ' + IntToStr(NumberOfList) + ', : ' + m_MemberNumberStr + ', : ' + m_MapNumberStr)
      else
        Begin
        ParamVal.CommaText := Reply.Strings[NumberOfList+2];
        GetOfNumber := TNObjectParameter.Create(StrToInt(ParamVal.Strings[0]),m_MemberNumber,m_MapNumber);
        End;
    end;
  FreeAndNil(Reply);
  FreeAndNil(ParamVal);
  END;

//------------------------------------------------------------------------------
//GetOfCode
function TNObjectParameters.GetOfCode(Code:Integer):TNObjectParameter;
  VAR Reply:TStringList;
      ParamVal:TStringList;
      FirstString:String;
      TempParam:TNObjectParameter;
      EqualParam:TNObjectParameter;
      i:Integer;
  BEGIN
  EqualParam := nil;
  Reply := TStringList.Create;
  ParamVal := TStringList.Create;
  ParamVal.Delimiter := ' ';
  if m_MapNumber = -1 then
    begin
    Reply.LoadFromStream(Connector.SendRStream('Map.GetObjectParameters '+ m_MemberNumberStr));
    FirstString := Reply.Strings[0];
    if FirstString[1] = '<' then
      raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr + ',  ')
    else
        for i:= 3 to Reply.Count-1 do
          Begin
          ParamVal.CommaText := Reply.Strings[i];
          TempParam := TNObjectParameter.Create(StrToInt(ParamVal.Strings[0]),m_MemberNumber,m_MapNumber);
          if Code = TempParam.Code then
            Begin
            EqualParam := TempParam;
            Break;
            End;
          End;

    if EqualParam = nil then
      raise ENObjectNotExist.Create('     : ' + IntToStr(Code) + ', : ' + m_MemberNumberStr + ',  .')
    else
      GetOfCode := EqualParam;
    end
  else
    begin
    Reply.LoadFromStream(Connector.SendRStream('Map[' + m_MapNumberStr + '].GetObjectParameters ' + m_MemberNumberStr));
    FirstString := Reply.Strings[0];
    if FirstString[1] = '<' then
      raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr + ', : ' + m_MapNumberStr)
    else
        for i:= 3 to Reply.Count-1 do
          Begin
          ParamVal.CommaText := Reply.Strings[i];
          TempParam := TNObjectParameter.Create(StrToInt(ParamVal.Strings[0]),m_MemberNumber,m_MapNumber);
          if Code = TempParam.Code then
            Begin
            EqualParam := TempParam;
            Break;
            End;
          End;

    if EqualParam = nil then
      raise ENObjectNotExist.Create('     : ' + IntToStr(Code) + ', : ' + m_MemberNumberStr + ', : ' + m_MapNumberStr)
    else
      GetOfCode := EqualParam;
    end;

  FreeAndNil(Reply);
  FreeAndNil(ParamVal);
  END;

//------------------------------------------------------------------------------
//GetOfName
function TNObjectParameters.GetOfName(Name:String):TNObjectParameter;
  VAR Reply:TStringList;
      ParamVal:TStringList;
      FirstString:String;
      TempParam:TNObjectParameter;
      EqualParam:TNObjectParameter;
      i:Integer;
  BEGIN
  EqualParam := nil;
  Reply := TStringList.Create;
  ParamVal := TStringList.Create;
  ParamVal.Delimiter := ' ';
  if m_MapNumber = -1 then
    begin
    Reply.LoadFromStream(Connector.SendRStream('Map.GetObjectParameters '+ m_MemberNumberStr));
    FirstString := Reply.Strings[0];
    if FirstString[1] = '<' then
      raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr + ',  ')
    else
        for i:= 3 to Reply.Count-1 do
          Begin
          ParamVal.CommaText := Reply.Strings[i];
          TempParam := TNObjectParameter.Create(StrToInt(ParamVal.Strings[0]),m_MemberNumber,m_MapNumber);
          if Name = TempParam.Name then
            Begin
            EqualParam := TempParam;
            Break;
            End;
          End;

    if EqualParam = nil then
      raise ENObjectNotExist.Create('     : ' + Name + ', : ' + m_MemberNumberStr + ',  ')
    else
      GetOfName := EqualParam;
    end
  else
    begin
    Reply.LoadFromStream(Connector.SendRStream('Map[' + m_MapNumberStr + '].GetObjectParameters ' + m_MemberNumberStr));
    FirstString := Reply.Strings[0];
    if FirstString[1] = '<' then
      raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr + ', : ' + m_MapNumberStr)
    else
        for i:= 3 to Reply.Count-1 do
          Begin
          ParamVal.CommaText := Reply.Strings[i];
          TempParam := TNObjectParameter.Create(StrToInt(ParamVal.Strings[0]),m_MemberNumber,m_MapNumber);
          if Name = TempParam.Name then
            Begin
            EqualParam := TempParam;
            Break;
            End;
          End;

    if EqualParam = nil then
      raise ENObjectNotExist.Create('     : ' + Name + ', : ' + m_MemberNumberStr + ', : ' + m_MapNumberStr)
    else
      GetOfName := EqualParam;
    end;

  FreeAndNil(Reply);
  FreeAndNil(ParamVal);
  END;

{===============================================================================
======================================TNObject==================================TNObject
===============================================================================}
constructor TNObject.Create(ObjectNumber:Integer; mMapNumber:Integer = -1);
  BEGIN
    inherited Create(ObjectNumber,mMapNumber);

    m_Layer := TNObjectLayer.Create(ObjectNumber,mMapNumber);
    m_Points := TNPoints.Create(ObjectNumber,mMapNumber);
    m_Parameters := TNObjectParameters.Create(ObjectNumber,mMapNumber);
  END;

//SetLayer
procedure TNObject.SetLayer(Value:TNObjectLayer);
  BEGIN
  Layer.LayerNumber := Value.LayerNumber;
  END;

//SetPoints
procedure TNObject.SetPoints(Value:TNPoints);
  VAR ReplyObj,ReplyVal:TStringList;
      i:Integer;
      Com:String;
      Reply:String;
  BEGIN
  ReplyObj := TStringList.Create;
  ReplyVal := TStringList.Create;
  if m_MapNumber = -1 then
    begin
    ReplyObj.LoadFromStream(Connector.SendRStream('Map.GetObjectCoordinates '+ m_MemberNumberStr));

    if Value.m_MapNumber = -1 then
      ReplyVal.LoadFromStream(Connector.SendRStream('Map.GetObjectCoordinates '+ Value.m_MemberNumberStr))
    else
      ReplyVal.LoadFromStream(Connector.SendRStream('Map['+Value.m_MapNumberStr+'].GetObjectCoordinates '+ Value.m_MemberNumberStr));

    if ReplyObj.Count = 1 then
      raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr + ',  ')
    else
      if ReplyVal.Count = 1 then
        raise ENObjectNotExist.Create('   : ' + Value.m_MemberNumberStr + ', :' + Value.m_MapNumberStr)
      else
        Begin
        Com := 'Map.PutObjectCoordinates '+ m_MemberNumberStr + NS;
        for i:= 0 to ReplyVal.Count - 1 do
          if i<2 then
            Com := Com + ReplyObj.Strings[i] + NS
          else
            Com := Com + ReplyVal.Strings[i] + NS;
        Reply := Connector.SendRStream(Com).DataString;
        End;
    end
  else
    begin
    ReplyObj.LoadFromStream(Connector.SendRStream('Map['+m_MapNumberStr+'].GetObjectCoordinates '+ m_MemberNumberStr));

    if Value.m_MapNumber = -1 then
      ReplyVal.LoadFromStream(Connector.SendRStream('Map.GetObjectCoordinates '+ Value.m_MemberNumberStr))
    else
      ReplyVal.LoadFromStream(Connector.SendRStream('Map['+Value.m_MapNumberStr+'].GetObjectCoordinates '+ Value.m_MemberNumberStr));

    if ReplyObj.Count = 1 then
      raise ENObjectNotExist.Create('   : ' + m_MemberNumberStr + ', : ' + m_MapNumberStr)
    else
      if ReplyVal.Count = 1 then
        raise ENObjectNotExist.Create('   : ' + Value.m_MemberNumberStr + ', :' + m_MapNumberStr)
      else
        Begin
        Com := 'Map.PutObjectCoordinates '+ m_MemberNumberStr + NS;
        for i:= 0 to ReplyVal.Count - 1 do
          if i<2 then
            Com := Com + ReplyObj.Strings[i] + NS
          else
            Com := Com + ReplyVal.Strings[i] + NS;
        Reply := Connector.SendRStream(Com).DataString;
        End;
    end;
  FreeAndNil(ReplyObj);
  FreeAndNil(ReplyVal);
  END;

procedure TNObject.Delete;
  VAR TempReply:String;
  BEGIN
  if m_MapNumber = -1 then
      Begin
      TempReply := Connector.SendRStream('Map.DeleteObject '+ m_MemberNumberStr).DataString;
      if TempReply <> m_MemberNumberStr then
          raise ENObjectNotExist.Create('    ' + m_MemberNumberStr +'  .   .');
      End
  Else
      Begin
      TempReply := Connector.SendRStream('Map['+m_MapNumberStr+'].DeleteObject '+ m_MemberNumberStr).DataString;
      if TempReply <> m_MemberNumberStr then
          raise ENObjectNotExist.Create('    ' + m_MemberNumberStr +'  '+m_MapNumberStr +'.   .');
      End;
  END;

{===============================================================================
======================================TNObjects=================================TNObjects
===============================================================================}
function TNObjects.GetOfNumber(NumberOfList:Integer):TNObject;
  VAR Reply:TStringList;
      FirstStr:String;
  BEGIN
  Reply := TStringList.Create();
  if m_MapNumber = -1 then
    Begin
    FirstStr := Connector.SendRStream('Map.SelectAll').DataString;
    if NumberOfList > StrToInt(FirstStr) then
      raise ENObjectNotExist.Create('    '+ IntToStr(NumberOfList)+ ',  .')
    else
      Begin
      Reply.LoadFromStream(Connector.SendRStream('Map.Selected.List'));
      FirstStr := Connector.SendRStream('Map.DeselectAll').DataString;
      GetOfNumber := TNObject.Create(StrToInt(Reply.Strings[NumberOfList-1]),m_MapNumber);
      End;
    End
  else
    Begin
    FirstStr := Connector.SendRStream('Map['+m_MapNumberStr+'].SelectAll').DataString;
    if FirstStr[1] = '<' then
      raise ENObjectNotExist.Create('   : ' +m_MapNumberStr)
    else
      if NumberOfList > StrToInt(FirstStr) then
        raise ENObjectNotExist.Create('    '+ IntToStr(NumberOfList)+ ', : '+ m_MapNumberStr)
      else
        Begin
        Reply.LoadFromStream(Connector.SendRStream('Map['+m_MapNumberStr+'].Selected.List'));
        FirstStr := Connector.SendRStream('Map['+m_MapNumberStr+'].DeselectAll').DataString;
        GetOfNumber := TNObject.Create(StrToInt(Reply.Strings[NumberOfList-1]),m_MapNumber);
        End;
    End;
  FreeAndNil(Reply);
  END;

//GetCount
function TNObjects.GetCount():Integer;
  VAR  FirstStr:String;
  BEGIN
  if m_MapNumber = -1 then
    Begin
    FirstStr := Connector.SendRStream('Map.SelectAll').DataString;
    GetCount := StrToInt(FirstStr);
    End
  else
    Begin
    FirstStr := Connector.SendRStream('Map['+m_MapNumberStr+'].SelectAll').DataString;
    if FirstStr[1] = '<' then
      raise ENObjectNotExist.Create('   : ' +m_MapNumberStr)
    else
      GetCount := StrToInt(FirstStr);
    End;
  END;

//Add
function TNObjects.Add(mLayer:TNMapLayer; mMapNumber:Integer = -1):Integer;
  VAR Reply:String;
  BEGIN
  if m_MapNumber = -1 then
    Begin
    Reply :=  Connector.SendRStream('Map.NewObject '+mLayer.m_MemberNumberStr + ' 100' ).DataString;
    Add := StrToInt(Reply);
    End
  else
    Begin
    Reply :=  Connector.SendRStream('Map['+m_MapNumberStr+'].NewObject '+mLayer.m_MemberNumberStr + ' 100' ).DataString;
    if Reply[1] = '<' then
      raise ENObjectNotExist.Create('   : ' + m_MapNumberStr)
    else
      Begin
      Add := StrToInt(Reply);
      End;
    End;
  END;

{===============================================================================
======================================TNMap=====================================TNMap
===============================================================================}
constructor TNMap.Create(mMapNumber:Integer = -1);
  BEGIN
    inherited Create(mMapNumber);

    m_Objects := TNObjects.Create(mMapNumber);
    m_Layers := TNMapLayers.Create(mMapNumber);
    m_Parameters := TNMapParameters.Create(mMapNumber);
  END;

constructor TNMap.Create(Template:String);
  VAR NewMapNumber:Integer;
      MapCount:Integer;
  BEGIN
  MapCount := StrToInt(Connector.SendRStream('MapCount').DataString);
  NewMapNumber := StrToInt(Connector.SendRStream('FileOpen ' + TempLate).DataString);
  if NewMapNumber > MapCount then
    Create(NewMapNumber)
  else
    raise ENTemplateNotFind.Create('  "'+ TempLate + '"  .');
  END;

//GetName
function TNMap.GetName():String;
  VAR Reply:String;
  BEGIN
  if m_MapNumber = -1 then
    Begin
    Reply := Connector.SendRStream('Map.FileName').DataString;
    if Reply[1] = '<' then
      raise ENObjectNotExist.Create('    .   .')
    else
      GetName := Reply;
    End
  else
    Begin
    Reply := Connector.SendRStream('Map['+m_MapNumberStr+'].FileName').DataString;
    if Reply[1] = '<' then
      raise ENObjectNotExist.Create('   : ' + m_MapNumberStr)
    else
      GetName := Reply;
    End;
  END;

//------------------------------------------------------------------------------
procedure TNMap.SaveAs(mName:String);
  VAR Reply:String;
  BEGIN
  if m_MapNumber = -1 then
    Begin
    Reply := Connector.SendRStream('Map.SaveToFile '+mName).DataString;
    End
  else
    Begin
    Reply := Connector.SendRStream('Map['+m_MapNumberStr+'].SaveToFile '+mName).DataString;
    End;
  END;

function TNMap.SelectedObjects():TNObjectList;
  VAR TempObjectsList:TNObjectList;
      TempStr:TStringStream;
  BEGIN
  TempObjectsList := TNObjectList.Create(m_MapNumber);
  if m_MapNumber = -1 then
    TempStr := Connector.SendRStream('Map.Selected.List')
  else
    TempStr := Connector.SendRStream('Map['+IntToStr(m_MapNumber)+'].Selected.List');

  if TempStr.DataString <> '0' then
    TempObjectsList.LoadNumberList(TempStr);

  SelectedObjects := TempObjectsList;
  END;

{===============================================================================
======================================TNObjectList==============================TNObjectList
===============================================================================}
constructor TNObjectList.Create(mMapNumber:Integer = -1);
  BEGIN
    inherited Create();
  m_MapNumber := mMapNumber;
  END;

//------------------------------------------------------------------------------
function TNObjectList.GetObject(ObjectNumber:Integer):TNObject;
  var TempObject:TNObject;
  BEGIN
  GetObject := TNObject.Create(StrToInt(Strings[ObjectNumber-1]),m_MapNumber);
  END;

//------------------------------------------------------------------------------
function TNObjectList.AddObject(ObjectNumber:Integer):Integer;
  BEGIN
  Add(IntToStr(ObjectNumber));
  AddObject := Count;
  END;

//------------------------------------------------------------------------------
procedure TNObjectList.LoadNumberList(NumbersObject:TStream);
  BEGIN
  LoadFromStream(NumbersObject);
  END;

end.
